"use strict";

var oex = window.opera.extension, cfg = (window.widget||{}).preferences, toutb, fields, keys, sieve_set, rgxNewLine, rgxHash = /^[^#]*#([^\/]+).*$/, menu;

window.onhashchange = function(e) {
	var args = [],
		old = e.oldURL.indexOf('#') > -1 ? e.oldURL.replace(rgxHash, '$1') : 'viewer',
		hash = e.newURL.indexOf('#') > -1 ? e.newURL.substr(e.newURL.indexOf('#') + 1) : 'viewer';

	if (hash.indexOf('/') > -1) {
		args = hash.split('/');
		hash = args.shift();
	}

	if (old != hash && window[old + '_sec']) {
		(window[old + '_sec'].style.display = 'none');
	}

	window[hash + '_sec'] && (window[hash + '_sec'].style.display = 'block');

	menu.active && menu.active.classList.remove('active');
	(menu.active = menu.querySelector('a[href="#' + hash + '"]')).classList.add('active');

	switch (hash) {
		case 'camera' :
			CameraUI.init();
		break;

		case 'sieve' :
			sieveUI.load();
		break;
		case 'history' :
			if (!HistoryUI.loaded) {
				HistoryUI.load();
				HistoryUI.loaded = true;
			}
		break;
/*		case 'info' :

			if (args[0] == 'undefined') {
				welcome.style.display = 'block';
			}
			else if (args[0] == 'update') {
				update.style.display = 'block';
			}
			else if (args[0]) {
				alert('woohoooo ' + args[0])
			}

			if (news_container.innerText.length < 20) {
				var XHR = new XMLHttpRequest();
				XHR.onreadystatechange = function () { if (XHR.readyState == 4 && this.status === 200) { news_container.innerHTML = XHR.responseText; } };
				XHR.open('GET', 'url', true);
				XHR.send(null);
			}
		break;*/
	}
};

window.addEventListener('load', function() {
	if (!window.opera || window.opera.version() < 11.5) {
		document.body.innerHTML = '<div class="versionError">This was made for Opera 10.50+!<br><span style="font-size:12px">Your version: ' + window.opera.version() + '</span><br><br><a href="http://my.opera.com/community/download.pl?ref=Deathamns&p=opera_desktop">Get the newest Opera!</a></div>';
		return;
	}

	window.widget && (document.getElementById('imagus_version').textContent = widget.name + ' v' + widget.version);

	menu = document.body.querySelector('nav');
	window.onhashchange({newURL: window.location.hash || '#viewer', oldURL: '#viewer'});

	keys = document.querySelectorAll('input[name^="tools_key-"][maxlength]');
	fields = document.querySelectorAll('input[name*=_], select[name*=_], textarea[name*=_]');

	for (var key in keys) { keys[key].onkeypress = ck; }
	document.forms[0].onformchange = function () { document.getElementById('save_button').style.color = 'orange'; };
	load();

	document.getElementById('reset_button').onclick = function (e) {
		if (!window.confirm('Are you sure?')) {
			e.preventDefault();
		}
	};

	document.getElementById('save_button').onclick = function () {
		this.style.color = 'green';
		clearTimeout(toutb);
		toutb = setTimeout(function(t) { return function() { t.style.color = ''; } }(this), 2000);
		save();
		return !1
	};

	rgxNewLine = /(?:\n|\r\n?)+/;
});

var sieveUI = {
	loaded: false,
	lastClicked: null,
	load: function () {
		if (this.loaded) { return; }
		var name, sfrag = document.createDocumentFragment(), row;

		sieve_set = JSON.parse(cfg.sieve || '{}');

		for (name in sieve_set) { sfrag.appendChild(sieveUI.gen(name, sieve_set[name])); }

		sieve_container.innerHTML = '';
		sieve_container.appendChild(sfrag);

		sieve_container.onkeypress = function (e) {
			if (e.target.nodeName != 'SPAN') { return; }
			if (e.keyCode === 27 || e.keyCode === 13) {
				e.preventDefault();
				e.target.parentNode.querySelector('input[type="text"]:nth-child(5)').focus();
				e.target.contentEditable = false;
				e.target.className = '';
			}
		};

		sieve_container.onmousedown = sieveUI.move;
		sieve_container.onclick = sieveUI.click;
		sieve_container.oncontextmenu = sieveUI.rename_del;

		document.getElementById('sieve_search').onkeypress = function (e) {
			if (e.keyCode == 27) {
				this.value = '';
				e.preventDefault();
			}
			else if (e.keyCode == 13) {
				e.preventDefault();
			}
		};

		document.getElementById('sieve_search').onkeyup = function (e) {
			sieveUI.search(this.value, event);
		};

		this.loaded = true;
	},
	gen: function (n, sd) {
		sd = sd || {};
		var r = document.createElement('DIV'), rgxQuote = /"/g, rgxBSlash = /\\\//g;
		sd.off && r.classList.add('disabled');
		r.rule = true;
		r.innerHTML = '<span>' + (n || '') + '</span><div>\
<label><input type="checkbox" name="loop"' + (sd.loop ? ' checked': '') +'> Loop </label>\
<label><input type="checkbox" name="decode"' + (sd.decode ? ' checked': '') +'> DecodeURL </label>\
<label><input type="checkbox" name="useimg"' + (sd.useimg ? ' checked': '') +'> Use img </label>\
<input type="text" name="link" value="' + (sd.link ? sd.link.substr(1).replace(rgxQuote, '&quot;').replace(rgxBSlash, '/') : '') + '" placeholder="link"><input type="checkbox" name="link_case"' + (sd.link && sd.link.substr(0, 1) == 'i' ? ' checked' : '') + ' title="case-sensitive">\
<input type="text" name="url" value="' + (sd.url ? sd.url.replace(rgxQuote, '&quot;') : '') + '" placeholder="url">\
<input type="text" name="res" value="' + (sd.res ? sd.res.replace(rgxQuote, '&quot;').replace(rgxBSlash, '/') : '') + '" placeholder="res">\
<input type="text" name="img" value="' + (sd.img ? sd.img.substr(1).replace(rgxQuote, '&quot;').replace(rgxBSlash, '/') : '') + '" placeholder="img"><input type="checkbox" name="img_case"' + (sd.img && sd.img.substr(0, 1) == 'i' ? ' checked' : '') + ' title="case-sensitive">\
<textarea name="to"placeholder="to">' + (sd.to ? sd.to.replace(/</g, '&lt;') : '') + '</textarea>\
<textarea name="note" value="" placeholder="note">' + (sd.note ? sd.note.replace(/</g, '&lt;') : '') + '</textarea></div>';
		return r;
	},
	add: function () {
		if (sieve_container.firstElementChild) {
			sieve_container.insertBefore(this.gen(), sieve_container.firstElementChild);
		}
		else {
			sieve_container.appendChild(this.gen());
		}

		sieve_container.firstElementChild.className = 'opened';
		sieve_container.firstElementChild.firstElementChild.contentEditable = true;
		sieve_container.firstElementChild.firstElementChild.className = 'focus';
		sieve_container.firstElementChild.firstElementChild.focus();
	},
	select: function (type) {
		for (var i = 0; i < sieve_container.childElementCount; ++i) { sieve_container.childNodes[i].classList[type]('selected'); }
	},
	click: function (e) {
		if (e.target.nodeName != 'SPAN') { return; }
		if (e.button === 0) {
			if (e.shiftKey && sieveUI.lastClicked != null) {
				var child = e.target.parentNode, currentIndex = 0, from, to, to_class = sieve_container.childNodes[sieveUI.lastClicked].classList.contains('selected') ? 'add' : 'remove';
				while(child = child.previousElementSibling) currentIndex++;

				from = Math.min(sieveUI.lastClicked, currentIndex);
				to = Math.max(sieveUI.lastClicked, currentIndex);

				for (;from <= to; ++from) { sieve_container.childNodes[from].classList[to_class]('selected'); }
			}
			else if (e.ctrlKey || e.metaKey) {
				sieveUI.lastClicked = 0;
				var child = e.target.parentNode;
				while(child = child.previousElementSibling) sieveUI.lastClicked++;

				e.target.parentNode.classList.toggle('selected');
				e.preventDefault();
			}
			else if (!e.target.isContentEditable) {
				e.target.parentNode.classList.toggle('opened');
			}
		}
	},
	move: function (e) {
		var div = e.target.parentNode, i, list;

		if (e.target.isContentEditable || e.target.nodeName != 'SPAN' || div.classList.contains('opened') || e.button !== 0 ) { return; }
		e.preventDefault();

		document.onmousemove = function (e) {
			if (!div.classList.contains('move')) {
				div.classList.add('move');
				list = sieve_container.querySelectorAll('.selected, .move');

				for (i = 0; i < list.length; ++i) { if (div != list[i]) { list[i].classList.add('move_multi'); } }
			}

			div.style.cssText = 'left:' + (e.clientX + 15) + 'px;top:' + (e.clientY + 15) + 'px';
		};

		/*sieve_container.onmouseover = function (e) {
			if (e.fromElement.id == 'sieve') { return; }
			if (e.target.parentNode.rule) { e.target.parentNode.style.marginLeft = '25%'; }
			else if (e.toElement.style.marginLeft != '0') { e.fromElement.style.marginLeft = '0'; }
		};*/

		document.onmouseup = function (e) {
			if (div.classList.contains('move') && e.target.parentNode.rule) {
				var dcfr = document.createDocumentFragment();

				for (i = 0; i < list.length; ++i) {
					sieve_container.removeChild(list[i]);
					dcfr.appendChild(list[i]);
				}

				sieve_container.insertBefore(dcfr, e.target.parentNode);
			}

			div.classList.remove('move');
			list = sieve_container.querySelectorAll('.move_multi');

			for (i = 0; i < list.length; ++i) { list[i].classList.remove('move_multi'); }

			sieve_container.onmouseover = document.onmouseup = document.onmousemove = null;
		};
	},
	imprt: function () {
	},
	exprt: function () {
		if (sieve_container.childElementCount) {
			var i, list = sieve_container.querySelectorAll('div.selected'), exp = {};

			if (list.length) {
				for (i = 0; i < list.length; ++i) { exp[list[i].firstElementChild.innerText] = sieve_set[list[i].firstElementChild.innerText]; }
			}
			else { exp = sieve_set; }

			window.open('data:application/javascript,' + encodeURIComponent(JSON.stringify(exp)));
		}
	},
	disable: function () {
		var i = sieve_container.childElementCount, list = sieve_container.querySelectorAll('div.selected').length, cn = sieve_container.childNodes;
		while (i--) { if (!list || cn[i].classList.contains('selected')) { cn[i].classList.toggle('disabled'); } }
	},
	remove: function () {
		if (confirm('Remove all or selected items?')) {
			var i = 0, list = sieve_container.querySelectorAll('div.selected');
			if (list.length) { for (;i < list.length; ++i) { sieve_container.removeChild(list[i]); } }
			else { sieve_container.innerHTML = ''; }
		}
	},
	rename_del: function (e) {
		if (e.target.nodeName != 'SPAN') { return; }

		if (e.shiftKey) {
			e.preventDefault();
			e.target.contentEditable = !e.target.isContentEditable;
			e.target.className = e.target.isContentEditable ? 'focus' : '';
		}
		else if (e.ctrlKey) {
			if (confirm('Sure you want to remove this rule?')) { e.target.parentNode.parentNode.removeChild(e.target.parentNode); }

			e.preventDefault();
		}
	},
	search: function (what, ev) {
		var i = 0, list = sieve_container.childNodes;
		what = what.toLowerCase();
		for (; i < list.length; ++i) { list[i].style.display = (what == '' || list[i].innerText.toLowerCase().indexOf(what) > -1) ? 'block' : 'none'; }
	},
	update: function () {
		if (sieve_container.childElementCount === 0 || confirm('Any modifications will be lost!\nUpdate anyway?')) {
			cfg.removeItem('sieve');
			oex.bgProcess.update_prefs();
			setTimeout(function() {
				window.location.reload();
			}, 3000);
		}
	}
},
HistoryUI = {
	loaded: false,
	page: 1,
	pages: 1,
	where: null,
	orderby: 'date',
	ascdesc: 'DESC',
	ipp: 25,
	total: 0,
	search_f: null,
	rgxName: /[^\/]*$/,
	init: function (ipp) {
		this.ipp = ipp || this.ipp;

		this.search_f = document.getElementById('history_search');
		this.search_f.onkeypress = function (e) {
			if (e.keyCode == 27) {
				this.value = '';
				HistoryUI.where = null;
				HistoryUI.load();
				e.preventDefault();
			}
			else if (e.keyCode == 13) {
				HistoryUI.where = this.value ? ["(',' || label || ',') LIKE '%," + this.value.replace("'", "\\'") + ",%'"] : null;
				HistoryUI.load();
				e.preventDefault();
			}
		};

		history_container.nextElementSibling.onclick = history_container.previousElementSibling.onclick = function (e) {
			if (e.target.nodeName.toUpperCase() == 'A') {
				HistoryUI.page = e.target.innerText;
				HistoryUI.load();
			}
		};
	},
	drop: function (force) {
		if (force || confirm('Remove all or selected items?')) {
			oex.bgProcess.SQL.run('DROP TABLE history');
			oex.bgProcess.SQL.db = null;
			history_container.innerHTML = '<h3 class="container_info">Empty...</h3>';
			history_container.nextElementSibling.innerHTML = history_container.previousElementSibling.innerHTML = '';
		}
	},
	//(',' || label || ',') LIKE '%,test1,%'
	gen: function (r) {
		var labels, source = '', tmpdiv = document.createElement('div');

		labels = r.label == null ? '' : r.label.split(',').map(function (label) { return '<a onclick="HistoryUI.search_f.value=\'' + label + '\'">' + label + '</a>'} ).join(', ') + '<br>';
		if (r.source != null) {
			r.source.split('\n').forEach(function (el) {

				switch (el.charAt(0)) {
					case 's': source += '<a href="' + el.substr(2) + '">Source</a>'; break;
					case 't': source += '<a href="' + el.substr(2) + '">Target</a>'; break;
				}
			});
		}

		tmpdiv.innerHTML = '<a href="' + r.image + '" rel="nofollow">' + (r.thumb == null ? r.image.match(this.rgxName)[0] : '<div style="height:' + Math.min(Math.round(Math.min(r.width, 110) * r.height / r.width), 200) + 'px;background:url(data:image/jpeg;base64,' + r.thumb + ') no-repeat center top"><span>' + r.width + 'x' + r.height + '</span><br><span>' + decodeURIComponent(r.image.match(this.rgxName)[0]) + '</span></div>') + '</a>' + r.date + '<div>' + labels + '</div>' + source;

		tmpdiv.oncontextmenu = function (e) {
			if (e.ctrlKey && e.button == 2) {
				e.preventDefault();
				HistoryUI.remove([this]);
			}
		};

		return tmpdiv;
	},
	limit: function () {
		var limit;

		if (HistoryUI.pages == HistoryUI.page) {
			limit = HistoryUI.total % HistoryUI.ipp;

			if (limit == 0) {
				limit = HistoryUI.ipp;
			}
		}
		else {
			limit = HistoryUI.ipp;
		}

		return ' LIMIT ' + (HistoryUI.ipp * (HistoryUI.page - 1)) + ' ,' + limit;
	},
	load: function () {
		if (this.process) { return; }
		else { this.process = true; }

		oex.bgProcess.SQL.run("SELECT COUNT(*) AS c FROM history", [], function (qcq, qcr) {
			HistoryUI.total = qcr.rows[0].c;

			if (HistoryUI.total < 1) {
				HistoryUI.drop(true);
				return;
			}
			else {
				if (HistoryUI.total <= HistoryUI.ipp) {
					HistoryUI.pages = HistoryUI.page = 1;
				}
				else {
					HistoryUI.pages = Math.ceil(HistoryUI.total / HistoryUI.ipp);
					HistoryUI.page = Math.max(1, Math.min(HistoryUI.page, HistoryUI.pages));
				}

				oex.bgProcess.SQL.run("SELECT image, strftime('%Y-%m-%d %H:%M:%S', date) AS date, width, height, source, label, thumb FROM history" + (HistoryUI.where ? ' WHERE ' + HistoryUI.where.join(' AND '): '') + " ORDER BY " + HistoryUI.orderby + " " + HistoryUI.ascdesc + HistoryUI.limit(), [],
				function (tx, r) {
					var i, dfrag = document.createDocumentFragment(), pages = '';

					if (r.rows.length < 1) {
						history_container.innerHTML = '<h3 class="container_info">No match...</h3>';
						return;
					}

					if (HistoryUI.pages > 1) {
						for (i = 1; i <= HistoryUI.pages; ++i) {
							pages += '<a' + (HistoryUI.page == i ? ' class="active"' : '') +'>' + i + '</a>';
						}

						i = (HistoryUI.page - 1) * HistoryUI.ipp;
						pages += ' ' + (i + 1) + ' - ' + (i + r.rows.length) + ' of ' + HistoryUI.total;
					}

					history_container.nextElementSibling.innerHTML = history_container.previousElementSibling.innerHTML = pages;

					for (i = 0; i < r.rows.length; ++i) { dfrag.appendChild(HistoryUI.gen(r.rows[i])); }

					history_container.innerHTML = '';
					history_container.appendChild(dfrag);
				});
			}

			HistoryUI.process = false;
		});
	},
	remove: function (el) {
		el.forEach(function (elem, idx) {
			el[idx] = elem.firstElementChild.href;
			elem.parentNode.removeChild(elem);
		});

		oex.bgProcess.SQL.run("DELETE FROM history WHERE image IN (" + Array(el.length + 1).join('?, ').slice(0, -2) + ")", el);
		HistoryUI.load();
	}
},
CameraUI = {
	loaded: false,
	flip_state: {h: 1, v: 1},
	timer: null,
	init: function () {
		if (this.loaded) { return; }

		this.loaded = true;

		if (navigator.getUserMedia) {
			navigator.getUserMedia('video', function (stream) { video.src = stream; }, function (error) { camera_sec.innerHTML = "<h3>Couldn't get the stream...</h3>"; });
		}
		else {
			camera_sec.innerHTML = '<h3>getUserMedia is not supported in this version...</h3>';
		}
	},
	flip: function (v) {
		if (v) {
			this.flip_state.v = this.flip_state.v === 1 ? -1 : 1;
		}
		else {
			this.flip_state.h = this.flip_state.h === 1 ? -1 : 1;
		}

		video.style.OTransform = 'scale(' + this.flip_state.h + ', ' + this.flip_state.v + ')';
	},
	capture: function () {
		var c = document.createElement('canvas'),
				ctx = c.getContext('2d');

		c.width = video.videoWidth;
		c.height = video.videoHeight;

		c.style.maxWidth = 160 + 'px';
		c.style.maxHeight = (160 * c.height / c.width) + 'px';

		if (CameraUI.flip_state.h === -1 || CameraUI.flip_state.v === -1) {
			ctx.translate(CameraUI.flip_state.h === -1 ? c.width : 0, CameraUI.flip_state.v === -1 ? c.height : 0);
			ctx.scale(CameraUI.flip_state.h, CameraUI.flip_state.v);
		}

		ctx.drawImage(video, 0, 0);

		if (shot_slide.childElementCount > 15) {
			shot_slide.removeChild(shot_slide.lastElementChild);
		}

		shot_slide.insertBefore(c, shot_slide.firstChild);
	},
	shoot: function(s) {
		clearTimeout(this.timer);
		this.timer = setTimeout(this.capture, s * 1000);
	}
};

function load() {
	var i, m, mode, pref,
	prefs = {
		vw: JSON.parse(cfg['vw'] || '{}'),
		hz: JSON.parse(cfg['hz'] || '{}'),
		tools: JSON.parse(cfg['tools'] || '{}')
	};

	HistoryUI.init(prefs.tools.historyIPP);

	for(i = fields.length; i--;) {
		if (fields[i].disabled || fields[i].readOnly) { continue; }

		pref = fields[i].name.split('_');

		if (pref[0] == 'tools' && pref[1] == 'imgSendToHosts') {
			var shidx, shosts = [];

			for (shidx = 0; shidx < prefs.tools[pref[1]].length; ++shidx) {
				shosts.push(prefs.tools[pref[1]][shidx].join('|'));
			}

			fields[i].rows = shosts.length;
			fields[i].value = shosts.join('\n');
		}
		else if (pref[0] == 'tools' && pref[1] == 'grants') {
			shosts = [];
			m = prefs.tools[pref[1]];

			if (m && m.length) {
				for (shidx = 0; shidx < m.length; ++shidx) {
					shosts.push((m[shidx][0] ? m[shidx][0] : '') + (m[shidx][2] ? ( m[shidx][2] === 1 ? '!!' : '!') : ( m[shidx][2] === 0 ? '~~' : '~')) + (m[shidx][3] ? '#' + m[shidx][3].join(',') : '') + ':' + m[shidx][1]);
				}
			}

			fields[i].value = shosts.join('\n');
		}
		else if (pref[0] == 'tools' && pref[1].indexOf('key-') === 0) {
			m = pref[1].substr(4);

			if (prefs.tools['key_' + m]) {
				fields[i].value = prefs.tools['key_' + m] == '' ? '': String.fromCharCode(prefs.tools['key_' + m]);
			}
		}
		else {
			if (prefs[pref[0]] && prefs[pref[0]][pref[1]] !== undefined) {
				if (fields[i].type == 'checkbox') {
					fields[i].checked = !!prefs[pref[0]][pref[1]];
				}
				else {
					fields[i].value = prefs[pref[0]][pref[1]];

					if (fields[i].type == 'range' && fields[i].nextElementSibling && fields[i].nextElementSibling.type == 'color') {
						fields[i].nextElementSibling.style.opacity = fields[i].value;
					}
					else if (fields[i].type == 'text' && fields[i].previousElementSibling && fields[i].previousElementSibling.type == 'color') {
						fields[i].onchange = function () {
							this.previousElementSibling.value = /^#[0-9a-f]{6}/i.test(this.value) ? this.value : '#ffffff';
						};

						fields[i].onchange();

						fields[i].previousElementSibling.onchange = function () {
							this.nextElementSibling.value = this.value;
						};
					}
				}
			}
		}
	}
}

function save() {
	var i, j, m, pref,
		prefs = {vw: {}, hz: {}, tools: {}},
		host, shidx, shosts,
		rgxGrant = /^(vw|hz|hi)?(!!?|~~?)(#(?:[^,:]+,?\s*)+)?:(.+)/,
		options, rule, rules = document.querySelectorAll('#sieve_container > div');

	if (rules.length) {
		prefs.sieve = {};

		for (i = 0; i < rules.length; ++i) {
			rule = rules[i].firstElementChild.innerText;

			if (!rule.trim()) { return; }

			prefs.sieve[rule] = {};
			rules[i].classList.contains('disabled') && (prefs.sieve[rule].off = true);
			options = rules[i].querySelectorAll('input,textarea');

			for (j = 0; j < options.length; ++j) {
				switch (options[j].name) {
					case 'loop': case 'decode': case 'useimg':
						if (options[j].checked) { prefs.sieve[rule][options[j].name] = true; }
					break;

					case 'note':
						options[j].value = options[j].value.trim();
					case 'url': case 'to': case 'link': case 'img': case 'res':
						if (!/^\s*$/.test(options[j].value)) { prefs.sieve[rule][options[j].name] = options[j].value.replace(/\r\n?/g, '\n'); }
					break;

					case 'link_case': case 'img_case':
						var opt_name = options[j].name.split('_')[0];
						if (prefs.sieve[rule][opt_name]) { prefs.sieve[rule][opt_name] = (options[j].checked ? 'i' : ' ') + prefs.sieve[rule][opt_name]; }
					break;
				}
			}
		}
	}

	for (i = 0; i < fields.length; ++i) {
		if (fields[i].readOnly) { continue; }

		pref = fields[i].name.split('_');

		if (pref[0] == 'tools' && pref[1] == 'imgSendToHosts') {
			shosts = fields[i].value.trim().split(rgxNewLine);
			prefs.tools[pref[1]] = [];
			for (shidx = 0; shidx < shosts.length; ++shidx) {
				host = shosts[shidx].split('|');
				if (host.length === 2 && (/%(?:url|name)/).test(host[1])) { prefs.tools[pref[1]].push(host); }
			}
		}
		else if (pref[0] == 'tools' && pref[1] == 'grants') {
			if (fields[i].value == '') { continue; }
			var grnts = fields[i].value.trim().split(rgxNewLine), grant, s_rules;

			if (grnts.length) {
				prefs.tools.grants = [];

				for (shidx = 0; shidx < grnts.length; ++shidx) {
					if (grant = grnts[shidx].match(rgxGrant)) {
						host = [grant[1] ? grant[1] : null];
						host.push(grant[4]);

						if (grant[2][0] == '!') { host.push(grant[2][1] == '!' ? 1 : true); }
						else { host.push(grant[2][1] == '~' ? 0 : false); }

						if (grant[3]) {
							s_rules = grant[3].substr(1).split(/\s*,\s*/);

							if (rules.length) { for (var j = 0; j < s_rules.length; ++j) { if (!prefs.sieve[s_rules[j]]) { delete s_rules[j]; } } }

							if (s_rules.length) { host.push(s_rules); }
						}

						prefs.tools.grants.push(host);
					}
				}
			}
		}
		else if (pref[0] == 'tools' && pref[1].indexOf('key-') === 0) {
			prefs.tools['key_' + pref[1].substr(4)] = fields[i].value.charCodeAt(0);
		}
		else {
			if (prefs[pref[0]]) {
				if (fields[i].type == 'checkbox') {
					prefs[pref[0]][pref[1]] = fields[i].checked
				}
				else if (fields[i].type == 'number' || fields[i].classList.contains('number')) {
					prefs[pref[0]][pref[1]] = fields[i].min ? Math.max(fields[i].min, Math.min(fields[i].max, parseInt(fields[i].value, 10))) : parseInt(fields[i].value, 10);
					fields[i].value = prefs[pref[0]][pref[1]];
				}
				else {
					prefs[pref[0]][pref[1]] = fields[i].value;
				}
			}
		}
	}

	oex.postMessage({'cmd': 'broadcast', 'data': 'reinit', 'prefs': prefs});
	HistoryUI.ipp = prefs.tools.historyIPP || HistoryUI.ipp;
	HistoryUI.load();
}

function ck(e) {
	var t = e.target;

	if (' 8 9 13 35 36 37 39 46 53 68 88 100 120 '.indexOf(' ' + e.keyCode + ' ') > -1) {
		return true;
	}

	if (!e.shiftKey && !e.ctrlKey && !(e.keyCode > 47 && e.keyCode < 58 || e.keyCode > 64 && e.keyCode < 91 || e.keyCode > 96 && e.keyCode < 123)) {
		e.preventDefault();
		return false;
	}

	var val = String.fromCharCode(e.keyCode).toUpperCase();

	for (var i = 0; i < keys.length; ++i) {
		if (keys[i].value == val) {
			e.preventDefault();
			return false;
		}
	}

	t.value = val;
}