"use strict";

var cfg = {};

(function (win, doc) {

var
	ex, // for exception
	rgxIsSVG = /svgz?$/i,
	oex = opera['extension'],
	root = doc.documentElement,
	img = doc.querySelector('html:root>body img[src=""]'),
	isRaster = (img || {src: null}).src == win.location.href,
	isSVG = !isRaster && (doc instanceof win['SVGDocument'] || (root && root.nodeName.indexOf('svg') === 0) || rgxIsSVG.test(win.location.pathname));

if (isSVG && win.location.hash.indexOf('#IMAGUS_SVG') > -1) {
	if (win.location.hash.indexOf('#IMAGUS_SVG_GET') > -1) {
		var iter = 10, wh,
		sendDimensions = function () {
			if (!doc.documentElement) { return; }
			doc.documentElement.suspendRedraw && doc.documentElement.suspendRedraw(5000);
			if (isSVG = doc.documentElement.nodeName.indexOf('svg') === 0) {
				wh = {'w': parseInt(doc.documentElement.getAttribute('width'), 10), 'h': parseInt(doc.documentElement.getAttribute('height'), 10)};

				if (!wh['w'] || !wh['h']) {
					wh = doc.documentElement['getBBox']();
					if (!(!isNaN(parseFloat(wh.width)) && isFinite(wh.width))) { return; }
					wh = {'w': wh.width, 'h': wh.height};
				}
			}

			clearInterval(interv);
			win.parent.postMessage({'cmd': 'svg_info', 'svg': isSVG, 'url': win.location.href, 'wh': wh}, '*');
		},
		interv = setInterval(function () { sendDimensions(); if (--iter) { clearInterval(interv); return; } }, 500);

		doc.documentElement && sendDimensions();
	}

	return;
}

var notGranted = function (feature) {
	var i, j, rgxSite, blockaccess = false, grnts = cfg.tools.grants || [], cleanSieve = {};

	if (grnts && !grnts.length) { return blockaccess; }

	for (i = 0; i < grnts.length; ++i) {
		// all or specific feature
		if (grnts[i][0] === null || grnts[i][0] == feature) {
			// which site
			if (grnts[i][1] == '*' || ((grnts[i][2] === 1 || grnts[i][2] === 0) && (new RegExp(grnts[i][1], 'i')).test(win.location.href)) || win.location.href.indexOf(grnts[i][1]) > -1) {
				// sieve elements
				if (grnts[i][3]) {
					// block
					if (grnts[i][2]) {
						for (j = 0; j < grnts[i][3].length; ++j) { cleanSieve[grnts[i][3][j]] = true; }
					}
					// allow
					else {
						for (j in cfg.sieve) { cleanSieve[j] = true; }
						for (j = 0; j < grnts[i][3].length; ++j) { cleanSieve[grnts[i][3][j]] = false; }
					}
				}
				else {
					blockaccess = grnts[i][2] ? true : false;
				}
			}
		}
	}

	j = [];

	for (i in cleanSieve) {
		if (cleanSieve[i]) {
			if (feature == 'hi') {
				j.push(i);
			}
			else {
				delete cfg.sieve[i];
				blockaccess = false;
			}
		}
	}

	return j.length ? j.join('|') : blockaccess;
},
convertSieveFunctions = function () {
	var i, isfunc = /^:\n/;
	for (var i in cfg.sieve) {
		if (cfg.sieve[i].to && isfunc.test(cfg.sieve[i].to)) {
			cfg.sieve[i].to = new Function('var $ = arguments;' + cfg.sieve[i].to.substr(2));
		}
	}
},
sendHistory = function (data, asklabel) {
	if (isRaster) {
		data = {'image': img.src, 'size': [img.naturalWidth, img.naturalHeight]};

		if (doc.referrer) {
			data.source = doc.referrer;
		}
	}

	if (!data || !data.image || !/^http/.test(data.image) || (cfg.tools.historyMode && !data.manual && (data.size[0] < cfg.tools.historyMinSize || data.size[1] < cfg.tools.historyMinSize))) {
		return false;
	}

	delete data.size;

	if (asklabel !== undefined) {
		var label = {}, asklabel = win.prompt('Enter labels separated by commas:', typeof asklabel == 'string' ? asklabel : '');

		if (asklabel === null) {
			return;
		}
		else if (asklabel == '') {
			data.label = '';
		}
		else {
			asklabel = asklabel.replace(/(\s*,\s*)+/g, ',').replace(/\s+/g, ' ').split(',');
			asklabel.forEach(function (el, idx) {
				el = el.trim();

				if (el != '') {
					label[el.substr(0, 50)] = true;
				}
			});

			label = Object.keys(label).slice(0, 5);

			if (label.length) {
				data.label = label.join(',');
			}
		}
	}

	if (data.source) {
		data.source = 's:' + data.source.source + (data.source.target && data.source.target != data.image ? '\nt:' + data.source.target : '');
	}

	oex.postMessage({'cmd': 'history', 'data': data});
}


if (isRaster/* || (doc instanceof win['SVGDocument'] && doc.URL == win.top.location.href)*/) {
	oex.addEventListener('message', function (e) {
		if (!e.data['hello']) { return; }

		cfg = e.data['prefs'];

		if (cfg.vw.dam === 4 || notGranted('vw')) { return; }

		img.naturalWidth = 0;
		img.error = true;

		if (cfg.vw.dam === 5) {
			doc.body.style.padding = '0';
			img.onclick = win.onkeypress = win.onmousedown = win.onmouseup = win.onmousemove = null;
			return;
		}

		cfg.hz = false;

	//if (isRaster) {
		doc['head'].innerHTML = '';
		doc.body.innerHTML = '';

		if (cfg.vw.sitefavicon && win.location.protocol.indexOf('http') === 0 && win.location.href.lastIndexOf('.ico') !== win.location.href.length - 4) {
			doc['head'].innerHTML += '<link rel="shortcut icon" href="http://getfavicon.appspot.com/' + encodeURIComponent(win.location.href) + '?defaulticon=none">';
		}

		if (PVI) {
			if (cfg.vw['useSieve']) {
				convertSieveFunctions();
				PVI.target = doc.createElement('a');
				PVI.target.href = PVI.target.src = win.location.href;
				PVI.target.style.backgroundImage = 'none';
				PVI = PVI.find(null, PVI.target);

				if (Array.isArray(PVI)) {
					for (var i = 0; i < PVI.length; ++i) {
						if (PVI[i] == win.location.href) {
							PVI = PVI.slice(0, i);
							if (!PVI.length) { PVI = null; } else { PVI = PVI[0]; }
							// TODO: fallback
							break;
						}
					}
				}
				else if (PVI == win.location.href) { PVI = null; }

				if (PVI && cfg.vw['useSieve'] === 1 && !win.confirm(LN('IMG_LARGERAVAIL') + '\n')) { PVI = null; }
			}
			else { PVI = null; }

			if (PVI) {
				if (rgxIsSVG.test(PVI)) {
					win.location.href = PVI;
					return;
				}
				else {
					try { win.history.pushState(null, null, PVI); }
					catch (ex) {}
				}
			}
		}

		img = new Image();

		img.onerror = function() {
			img = {error: true};
			if (!doc.getElementById('imagus_CSS')) { sub_init(); }
			doc.body.innerHTML = '<h2>' + LN('IMG_FAILED') + '</h2>';
		};

		if (cfg.tools.historyMode) {
			img.onload = function() {
				setTimeout(sendHistory, 1234);
			};
		}

		img.src = typeof PVI == 'string' ? PVI : win.location.href;

		if (img.src.indexOf('data:') === 0) {
			img.alt = 'Image (inline)';
			doc.title = 'Image';
		}
		else {
			img.alt = decodeURIComponent(img.src.replace(/#.*/, '').match(/(?:[^\/]+)?$/)[0]) || 'Image';
		}

	/*}
	else {
		return;
		var img = '';
	}*/

		if (img.error) { return; }

		var sub_init,
			after_calc,
			histabel,
			sX, sY,
			noFit = {cur: false, real: false},
			progress = null,
			cancelAction = false,
			fZoom = null,
			pixelThresHold = 1,
			dragScroll = [],
			borderSize = 0,
			init = {loop: 0, wait: 300, maxLoop: 1000},
			MAXSIZE = 0x7fff;

		root || (root = doc.documentElement);

		root.style.cssText = 'width:100%;height:100%;';
		doc.body.style.cssText = 'width:100%;height:100%;';

		sub_init = function (first) {
			if (!/^[bts]:/.test(cfg.vw.imgInfo)) { cfg.vw.imgInfo = false; }

			var nodeStyle, docStyle = 'body{margin:0;padding:0;font:12px "Trebuchet MS",sans-serif}h2{padding-top:200px;text-align:center;text-shadow:1px 1px 15px #000;color:#fff;font:700 30px "Trebuchet MS",sans-serif}.m_1{max-width:100%;max-height:100%;width:auto;height:auto}.m_2{width:100%;height:auto}.m_3{height:100%;width:auto}',
				style = doc.createElement('style');

			style.id = 'imagus_CSS';

			root.style.overflow = cfg.vw.hideSB ? 'hidden' : 'auto';
			root.style.background = (cfg.vw.backg == 'cb' ? 'url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7)' : (!!cfg.vw.backg ? cfg.vw.backg : 'none'));

			nodeStyle = 'background:' + (cfg.vw.imgBg == 'cb' ? 'url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7)' : (!!cfg.vw.imgBg ? cfg.vw.imgBg : 'none')) + ';';

			if (!!cfg.vw.imgBorder) {
				nodeStyle += 'border:' + (img.style.border = cfg.vw.imgBorder) + ';';
				borderSize = parseInt(cfg.vw.imgBorder, 10);

				if (borderSize > 100) {
					nodeStyle += 'border-width:' + (borderSize = 100) + 'px !important;';
				}

				nodeStyle += 'background-clip:padding-box;box-sizing:border-box;';
			}

			docStyle += 'img{position:absolute;' + nodeStyle + '}';

			style.textContent = docStyle + 'body>img{max-width:' + Math.min(MAXSIZE, Math.floor(img.naturalWidth * MAXSIZE / img.naturalHeight)) + 'px;max-height:' + Math.min(MAXSIZE, Math.floor(img.naturalHeight * MAXSIZE / img.naturalWidth)) + 'px}';

			try { doc['head'].removeChild(style); }
			catch (ex) {}

			doc['head'].appendChild(style);

			if (img.naturalWidth === 0) {
				doc.body.innerHTML = '<h2>' + img.alt + '</h2>';
				doc.body.firstElementChild.onclick = function () { this.parentNode.appendChild(img); this.parentNode.removeChild(this); };
			}
		};

		var load = function(noneedinterval) {
			if (img.error) {
				if (progress) {
					clearInterval(progress);
				}
				return;
			}

			if (img.width > 0 || noneedinterval) {
				clearInterval(progress);
				progress = null;

				sub_init();

				doc.body.innerHTML = '';
				doc.body.appendChild(img);

				after_calc = function () {
					if (img.calcFit) {
						img.setPos();
						img.calcFit();
						img.hScroll();
						cfg.vw.cursor && img.setCur();
						img.setInfo();
					}
				};

				img.dam = cfg.vw.dam;

				img.resize = function(m, w, h) {
					if (m === 4) {
						this.dam = 4;
						this.style.display = 'none';
						this.parentNode.style.backgroundImage = 'url("' + this.src + '")';
						this.setPos();
						return;
					}
					else if (this.dam === 4) {
						this.style.display = 'block';
						this.parentNode.style.backgroundImage = '';
					}
					else if (m === -1 || (m === -1 && fZoom)) {
						this.style.width = w;
						h && (this.style.height = h);

						if ((w === '' || w === this.naturalWidth) && (h === '' || h === this.naturalHeight)) {
							m = 0;
						}
					}

					if (m !== -1 && this.dam === -1) {
						this.style.width = this.style.height = '';
					}

					this.className != 'm_' + m && (this.className = 'm_' + m);

					this.dam = m;

					this.naturalWidth && this.naturalHeight && after_calc();
				};

				img.setInfo = function() {
					if (!cfg.vw.imgInfo || !(img.naturalWidth && img.naturalHeight)) { return; }

					var fc = cfg.vw.imgInfo.charAt(0),
						info = cfg.vw.imgInfo.substr(2).replace('%w', img.width).replace('%h', img.height).replace('%ow', img.naturalWidth).replace('%oh', img.naturalHeight).replace('%url', win.location).replace('%name', img.alt).replace('%ratio', Math.round(img.width / img.height * 100) / 100);

					if (cfg.vw.imgInfo.indexOf('%perc') > 0) { info = info.replace('%perc', (~~(0.5 + 1E4 * (img.width / img.naturalWidth)) / 100)); }

					if (fc == 't') { doc.title = info; }
					else if (fc == 's') { win.status = info; }
					else if (fc == 'b') { doc.title = win.status = info; }
				};

				var hLayer, createHelper = function () {
					if (hLayer) { return; }

					hLayer = doc.createElement('div');
					hLayer.style.cssText = 'position:fixed;display:none;z-index:3;left:0;top:0;width:100%;height:100%;box-sizing:border-box;background-clip:padding-box';
					doc.body.appendChild(hLayer);
				};

				img.setPos = function() {
					if (cfg.vw.pos.length === 2) {
						var bgM = (this.dam === 4), bgPos = '';

						var r = this.currentdeg && Math.sin(this.currentdeg * 0.017453292519943295) == 0 ? true : false;
						// TODO: position of rotated images
						//console.log(this.currentdeg, Math.sin(this.currentdeg * 0.017453292519943295))

						switch (cfg.vw.pos.charAt(1)) {
							case '0' : if (bgM) { bgPos = 'top '; } else { this.style.top = '0'; } break;
							case '2' : if (bgM) { bgPos = 'bottom '; } else { this.style.top = Math.max(0, root.clientHeight - (r ? this.width : this.height) - borderSize * 2) + 'px'; } break;
							default: if (bgM) { bgPos = 'center '; } else { this.style.top = Math.max(0, (root.clientHeight - (r ? this.width : this.height)) / 2 - borderSize) + 'px'; } break;
						}

						switch (cfg.vw.pos.charAt(0)) {
							case '0' : if (bgM) { bgPos += 'left'; } else { this.style.left = '0'; } break;
							case '2' : if (bgM) { bgPos += 'right'; } else { this.style.left = Math.max(0, root.clientWidth - (r ? this.height : this.width) - borderSize * 2) + 'px'; } break;
							default : if (bgM) { bgPos += 'center'; } else { this.style.left = Math.max(0, (root.clientWidth - (r ? this.height : this.width)) / 2 - borderSize) + 'px'; } break;
						}

						if (bgM) {
							this.parentNode.style.backgroundPosition = bgPos;
						}
					}
				};

				img.calcFit = function () {
					noFit = {
						cur: (this.width <= win.innerWidth && this.height <= win.innerHeight),
						real: (this.naturalWidth <= win.innerWidth && this.naturalHeight <= win.innerHeight)
					};
				};

				img.wheelZoom = function (e) {
					e.preventDefault();

					var w = img.width + 2 * borderSize, h = img.height + 2 * borderSize;

					if (e.wheelDelta > 0) {
						var width = w * (e.altKey || e.accelerate ? 1.4 : 1.2);

						img.resize(-1, (width > 10 ? width : width + 3) + 'px', 'auto');
					}
					else {
						img.resize(-1, Math.max(1, w * (e.altKey || e.accelerate ? 0.6 : 0.8)) + 'px', 'auto');
					}

					if ((e.target.nodeName.toUpperCase() == 'IMG' || e.keypress)) {
						win.scrollTo(e.offsetX * (img.width + 2 * borderSize) / w - e.clientX + borderSize, e.offsetY * (img.height + 2 * borderSize) / h - e.clientY + borderSize);
					}
				};

				if (cfg.vw.scrollZoom) {
					img.hScroll = function () {};

					doc.addEventListener('mousewheel', img.wheelZoom);
				}
				else {
					if (cfg.vw.hideSB) {
						var onWheelVertical = function (e) {
							win.scrollBy(0, -e.wheelDelta);
							e.preventDefault();
						};

						doc.addEventListener('mousewheel', onWheelVertical);
					}

					var onWheelHorizontal = function (e) {
						win.scrollBy(-e.wheelDelta, 0);
						e.preventDefault();
					};

					img.hScroll = function (force) {
						switch (this.dam) {
							case -1:
							case 0: this.hS = (win.innerWidth < this.width && cfg.vw.hlonger && this.height <= (this.width / cfg.vw.hlonger) ? true : false); break;
							case 3: this.hS = (win.innerWidth < this.width ? true : false); break;
							default: this.hS = false; break;
						}

						if (force) {
							this.hS = !this.hS;

							win.onkeyup = function(e) {
								if (e.keyCode === 88) {
									img.hScroll();
									win.onkeyup = null;
								}
							};
						}

						doc[(this.hS ? 'add' : 'remove') + 'EventListener']('mousewheel', onWheelHorizontal);
						cfg.vw.hideSB && doc[(this.hS ? 'remove' : 'add') + 'EventListener']('mousewheel', onWheelVertical);
					};
				}

				img.setCur = function () {
					if (this.width > win.innerWidth || this.height > win.innerHeight) {
						this.style.cursor = 'move';
					}
					else if (((win.innerHeight >= this.height && win.innerWidth >= this.width) && (win.innerHeight < this.naturalHeight || win.innerWidth < this.naturalWidth)) ||
					(noFit.cur && noFit.real && (this.height < this.naturalHeight || this.width < this.naturalWidth))) {
						this.style.cursor = 'zoom-in';
					}
					else {
						this.style.cursor = 'default';
					}
				};

				win.addEventListener('resize', after_calc);

				var cxmenu, contextmenu = function (mx, my) {
					createHelper();

					if (hLayer.style.display == 'block') {
						cancelAction = false;
						hLayer.style.display = 'none';
						return;
					}

					hLayer.onmousedown = function (e) {
						if (!fZoom && e.target == hLayer) {
							cancelAction = false;
							this.style.display = 'none';
							this.onmousedown = null;
						}
					}

					if (!cxmenu) {
						document.getElementById('imagus_CSS').textContent += '#Im_CM{display:none;position:fixed;z-index:3}#Im_CM, #Im_CM ul{background-color:#f0f0f0;border:1px solid #a0a0a0;box-shadow:5px 5px 2px -3px #999;display:block;list-style:none;margin:0;padding:2px}#Im_CM li:not(:empty){position:relative;border:1px solid transparent;padding:5px;padding:2px 45px 2px 10px;white-space:nowrap;color:#000}#Im_CM li:hover:not(:empty) {background-color:#46a9ff;border:1px solid #1676ff;color:#fff}#Im_CM li>i{position:absolute;top:2px;right:5px;color:grey;font-style:normal}#Im_CM li:hover>*{color:#fff}#Im_CM li:empty{border-bottom:1px solid #fff;border-top:1px solid #a0a0a0;margin:5px 7px 4px}#Im_CM li>ul{display:none;left:100%;position:absolute;top:-5px}#Im_CM li:hover>ul{display:block}';
						cxmenu = doc.createElement('ul');
						cxmenu.onmousedown = function (e) { e.stopPropagation(); };
						cxmenu.id = 'Im_CM';

						var generateMenu = function (ext_menu_data) {
							var tmpel, mfragment = doc.createDocumentFragment(), ul, i, l;

							for (i = 0, l = ext_menu_data.length; i < l; ++i) {
								tmpel = doc.createElement('li');

								if (ext_menu_data[i].length) {
									tmpel.innerHTML = ext_menu_data[i][0] + (ext_menu_data[i][2] ? '<i>' + ext_menu_data[i][2] + '</i>': '');

									if (Array.isArray(ext_menu_data[i][1])) {
										if (!ext_menu_data[i][1].length) {
											continue;
										}

										ul = doc.createElement('ul');
										ul.appendChild(generateMenu(ext_menu_data[i][1]));
										tmpel.appendChild(ul);
									}
									else if (ext_menu_data[i][1]) {
										tmpel.onclick = ext_menu_data[i][1];
										tmpel.addEventListener('click', function (e) { if (!e.shiftKey) { hLayer.style.display = 'none'; } });
									}
								}

								mfragment.appendChild(tmpel);
							}

							return mfragment;
						};

						var $sendHosts = [], tmpel, mfragment = doc.createDocumentFragment();

						if (cfg.tools['imgSendToHosts'].length) {
							for (var shidx = 0; shidx < cfg.tools['imgSendToHosts'].length; ++shidx) {
								$sendHosts.push([cfg.tools['imgSendToHosts'][shidx][0].replace(/^\+/, ''),
									function(sf) {
										return function(e) {
											sf['nf'] = e.shiftKey;
											imageSendTo(sf);
										}
									}({'url': img.src, 'host': shidx})]
								);
							}

							//$sendHosts.push([LN('SENDTO_ALL'), function() { imageSendTo({'url': img.src, 'host': -1}); }]);
						}

						mfragment.appendChild(generateMenu([
							[LN('ORIGINAL_SIZE'), function() { img.resize(0); }, String.fromCharCode(cfg.tools['key_modeAuto'])],
							[LN('BEST_FIT'), function() { img.resize(1); }, String.fromCharCode(cfg.tools['key_modeFit'])],
							[LN('FIT_TO_WIDTH'), function() { img.resize(2); }, String.fromCharCode(cfg.tools['key_modeFitW'])],
							[LN('FIT_TO_HEIGHT'), function() { img.resize(3); }, String.fromCharCode(cfg.tools['key_modeFitH'])],
							[LN('MORE'), [
								[LN('TO_BACKGROUND'), function() { img.resize(4); }, String.fromCharCode(cfg.tools['key_modeBg'])],
								[LN('CUSTOM_SIZE'), function() { img.setSize(); }, String.fromCharCode(cfg.tools['key_customSize'])],
								[LN('RESET_IMAGE'), function() { img.reset(true); }, 'Esc']
							], '&#187;'],
							[],
							[LN('TRANSFORM'), [
								[LN('FLIP_H'), function() { transform.flip(img, 1); }, String.fromCharCode(cfg.tools['key_flipH'])],
								[LN('FLIP_V'), function() { transform.flip(img, 0); }, String.fromCharCode(cfg.tools['key_flipV'])],
								[],
								[LN('ROT_LEFT'), function() { img.rotate(false); }, String.fromCharCode(cfg.tools['key_rotateLeft'])],
								[LN('ROT_RIGHT'), function() { img.rotate(true); }, String.fromCharCode(cfg.tools['key_rotateRight'])],
								[LN('ROT_CUSTOM'), function() { img.rotate(); }, String.fromCharCode(cfg.tools['key_rotateCustom'])]
							], '&#187;'],
							[LN('SENDTO'), $sendHosts, '&#187;'],
							[LN('PREFERENCES'), function () { oex.postMessage({'cmd': 'open', 'url': 'options.html'}); }, String.fromCharCode(cfg.tools['key_prefs'])]
						]));

						cxmenu.style.display = 'display:block';
						cxmenu.appendChild(mfragment);
					}

					hLayer.appendChild(cxmenu);

					hLayer.style.border = '0';
					hLayer.style.left = '0';
					hLayer.style.top = '0';
					hLayer.style.width = '100%';
					hLayer.style.height = '100%';
					hLayer.style.display = 'block';
					cxmenu.style.left = (mx === undefined ? (win.innerWidth - cxmenu.offsetWidth) / 2 : mx) + 'px';
					cxmenu.style.top = (my === undefined ? (win.innerHeight - cxmenu.offsetHeight) / 2 : my) + 'px';
				};

				doc.addEventListener('contextmenu', function(e) {
					win.onmousemove = null;
					if (progress) { clearTimeout(progress); progress = null; }
					if (cancelAction === 2) { cancelAction = false; e.preventDefault(); }
				});

				var onmove = function (e) {
					if (fZoom) {
						if (fZoom.stage === 0) {
							if (!e.shiftKey) {
								fZoom = null;
								return;
							}

							createHelper();
							hLayer.innerHTML = '';
							cxmenu = null;

							var rot = img.currentdeg && Math.sin(img.currentdeg) ? true : false,
								w = rot ? img.height : img.width,
								h = rot ? img.width : img.height;
							if (w > win.innerWidth) {
								hLayer.style.left = parseInt(borderSize, 10);
								hLayer.style.width = win.innerWidth + 'px';
							}
							else {
								hLayer.style.left = (img.offsetLeft + borderSize) + 'px';
								hLayer.style.width = w + 'px';
							}

							if (h > win.innerHeight) {
								hLayer.style.top = parseInt(borderSize, 10);
								hLayer.style.height = win.innerHeight + 'px';
							}
							else {
								hLayer.style.top = (img.offsetTop + borderSize) + 'px';
								hLayer.style.height = h + 'px';
							}

							// helper width, height
							fZoom.hW = parseInt(hLayer.style.width, 10);
							fZoom.hH = parseInt(hLayer.style.height, 10);

							// helper top, left
							fZoom.hT = parseInt(hLayer.style.top, 10);
							fZoom.hL = parseInt(hLayer.style.left, 10);

							// helper right, bottom
							fZoom.hR = fZoom.hL + fZoom.hW;
							fZoom.hB = fZoom.hT + fZoom.hH;

							fZoom.t = Math.max(0, fZoom.cY - fZoom.hT);
							fZoom.b = Math.max(0, fZoom.hB - fZoom.cY);
							fZoom.l = Math.max(0, fZoom.cX - fZoom.hL);
							fZoom.r = Math.max(0, fZoom.hR - fZoom.cX);

							hLayer.style.borderStyle = 'solid';
							hLayer.style.borderColor = 'rgba(' + parseInt(cfg.vw.fZoomColor.substr(1,2), 16) + ',' + parseInt(cfg.vw.fZoomColor.substr(3,2), 16) + ',' + parseInt(cfg.vw.fZoomColor.substr(5,2), 16) + ',' + cfg.vw.fZoomOpacity + ')';

							hLayer.style.borderWidth = fZoom.t + 'px ' + fZoom.r + 'px ' + fZoom.b + 'px ' + fZoom.l + 'px';
							hLayer.style.display = 'block';

							++fZoom.stage;
						}
						else {
							if (e.ctrlKey) {
								if (fZoom.sX) {
									var x = fZoom.sX - e.screenX, y = fZoom.sY - e.screenY;

									if (y !== 0) {
										hLayer.style.borderBottomWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderBottomWidth, 10) + y), fZoom.hH) + 'px';
										hLayer.style.borderTopWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderTopWidth, 10) - y), fZoom.hH) + 'px';
									}

									if (x !== 0) {
										hLayer.style.borderRightWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderRightWidth, 10) + x), fZoom.hW) + 'px';
										hLayer.style.borderLeftWidth = Math.min(Math.max(0, parseInt(hLayer.style.borderLeftWidth, 10) - x), fZoom.hW) + 'px';
									}
								}

								fZoom.sX = e.screenX;
								fZoom.sY = e.screenY;

								return;
							}

							if (fZoom.sX) {
								fZoom.sX = null;
								fZoom.sY = null;
								/*fZoom.cX = fZoom.hL + (fZoom.cX < e.clientX ? parseInt(hLayer.style.borderLeftWidth, 10) : fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10));
								fZoom.cY = fZoom.hT + (fZoom.cY < e.clientY ? parseInt(hLayer.style.borderTopWidth, 10) : fZoom.hH - parseInt(hLayer.style.borderBottomWidth, 10));*/
								if (fZoom.hL + parseInt(hLayer.style.borderLeftWidth, 10) < e.clientX) { fZoom.cX = fZoom.hL + parseInt(hLayer.style.borderLeftWidth, 10); }
								else { fZoom.cX = fZoom.hL + fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10); }

								if (fZoom.hT + parseInt(hLayer.style.borderTopWidth, 10) < e.clientY) { fZoom.cY = fZoom.hT + parseInt(hLayer.style.borderTopWidth, 10); }
								else { fZoom.cY = fZoom.hT + fZoom.hH - parseInt(hLayer.style.borderBottomWidth, 10); }

								//borders
								fZoom.t = Math.max(0, fZoom.cY - fZoom.hT);
								fZoom.b = Math.max(0, fZoom.hB - fZoom.cY);
								fZoom.l = Math.max(0, fZoom.cX - fZoom.hL);
								fZoom.r = Math.max(0, fZoom.hR - fZoom.cX);
							}

							var t, r, b, l;

							if (fZoom.cY < e.clientY) {
								b = Math.max(0, fZoom.hB - e.clientY);
								t = fZoom.t;
							}
							else {
								b = fZoom.b;
								t = Math.max(0, e.clientY - fZoom.hT);
							}

							if (fZoom.cX < e.clientX) {
								r = Math.max(0, fZoom.hR - e.clientX);
								l = fZoom.l;
							}
							else {
								r = fZoom.r;
								l = Math.max(0, e.clientX - fZoom.hL);
							}

							hLayer.style.borderWidth = t + 'px ' + r + 'px ' + b + 'px ' + l + 'px';
						}

						return;
					}

					if (progress) { clearTimeout(progress); progress = null;}

					if (sX === true || cfg.vw.pixelmove < 1 || noFit.cur || !parseInt(cfg.vw.pixelmove, 10)) { win.onmousemove = null; return;}

					if (!--pixelThresHold) {
						win.scrollBy(sX - e.screenX, sY - e.screenY);

						sX = e.screenX;
						sY = e.screenY;
						pixelThresHold = cfg.vw.pixelmove;
					}

					if (dragScroll.length !== 3) {
						dragScroll = [ [e.screenX, e.screenY], [e.screenX, e.screenY], [e.screenX, e.screenY] ];
						return;
					}

					dragScroll[0] = [dragScroll[1][0], dragScroll[1][1]];
					dragScroll[1] = [dragScroll[2][0], dragScroll[2][1]];
					dragScroll[2] = [e.screenX, e.screenY];

					img.dragScrollTime = Date.now();
				};

				if (cfg.vw.pixelmove) {
					var stopScroll = function (e, c_action) {
						if (dragScroll.length) {
							clearInterval(progress);
							progress = null;
							cancelAction = c_action ? true : false;
							dragScroll = [];
							img.dragScrollTime = false;
						}

						if (e) {
							doc.removeEventListener('mousewheel', stopScroll);
						}
					};

					var startScroll = function () {
						progress = setInterval(function () {
							win.scrollBy(dragScroll[0], dragScroll[1]);

							if (dragScroll[0]) {
								if (Math.abs(dragScroll[0]) < 1) {
									dragScroll[0] = 0;
								}

								dragScroll[0] /= 1.11;
							}

							if (dragScroll[1]) {
								if (Math.abs(dragScroll[1]) < 1) {
									dragScroll[1] = 0;
								}

								dragScroll[1] /= 1.11;
							}

							var atRight = root.scrollWidth - win.scrollX === root.clientWidth,
								atBottom = root.scrollHeight - win.scrollY === root.clientHeight;

							if (!(dragScroll[0] && dragScroll[1]) || (!win.scrollY && !win.scrollX) || (!win.scrollY && atRight) || (atBottom && !win.scrollX) || (atBottom && atRight)) {
								stopScroll();
							}
						}, 25);
					};
				}

				var handle_mDown = function(e) {
					if (e.button === 1 || e.ctrlKey || e.altKey) { return; }

					if ((e.button === 0 && img.dam < 4) || e.button === 2) {
						if (cfg.vw.pixelmove) {
							win.onmousemove = onmove;
						}
						else {
							win.onmousemove = function () {if (progress) { clearTimeout(progress); progress = null; } win.onmousemove = null; };
						}

						if (e.button === 2) {
							sX = true;
						}
						else {
							e.preventDefault();
							sX = e.screenX;
							sY = e.screenY;
						}
					}

					if (!cfg.vw.lpDelay) {
						return;
					}

					// for fine move and free zoom
					if (e.shiftKey || fZoom === 0) {
						cancelAction = true;

						// contextmenu
						if (e.button === 2) {
							cancelAction = 2;
							contextmenu(e.clientX, e.clientY);
						}
						else {
							fZoom = {stage: 0, cX: e.clientX, cY: e.clientY};

							if (win.onmousemove === null) {
								win.onmousemove = onmove;
							}
						}
					}

					// is dragScrolling
					if (progress) {
						stopScroll && stopScroll(false, true);

						if (e.button === 0) {
							return;
						}
					}

					if (e.shiftKey || (e.button === 0 && !cfg.vw['lpLeft']) || (e.button === 2 && !cfg.vw['lpRight'])) { return; }

					progress = setTimeout(longpress_func, cfg.vw.lpDelay, e);
				};

				img.addEventListener('mousedown', handle_mDown);

				var longpress_func = function (e) {
					cancelAction = true;
					progress = null;

					// contextmenu
					if (e.button === 2) {
						switch (cfg.vw['lpRight']) {
							case 1:
								cancelAction = 2;
								try { if (img.src != win.top.location.href) { oex.postMessage({'cmd': 'open', 'url': img.src, nf: false}); return; } } catch (ex) {}
								contextmenu(e.clientX, e.clientY);
							break;
						}

						return;
					}

					switch (cfg.vw['lpLeft']) {
						case 1:
							var x, y, tmpsize;

							if (img.dam === 2 || img.width === win.innerWidth) {
								tmpsize = img.width;
								img.resize(3);
								x = e.offsetX * img.width / tmpsize - win.innerWidth / 2;
								y = 0;
							}
							else {
								tmpsize = img.height;
								img.resize(2);
								x = 0;
								y = e.offsetY * img.height / tmpsize - win.innerHeight / 2;
							}

							win.scrollTo(x, y);
						break;
					}
				};

				doc.addEventListener('mouseup', function(e) {
					if (e.button !== 0) { return; }

					if (img.dam < 4) {
						win.onmousemove = null;

						if (fZoom) {
							hLayer.style.display = 'none';
							var nimgw, nimgh,
							w = fZoom.hW - parseInt(hLayer.style.borderRightWidth, 10) - parseInt(hLayer.style.borderLeftWidth, 10),
							h = fZoom.hH - parseInt(hLayer.style.borderTopWidth, 10) - parseInt(hLayer.style.borderBottomWidth, 10),
							scrollbars = cfg.vw.hideSB ? 0 : 17, // not always 17
							winW = win.innerWidth - scrollbars,
							winH = win.innerHeight - scrollbars;

							var fitW = winW < w * winH / h;

							fitW = e.ctrlKey ? !fitW : fitW;

							if (fitW) {
								nimgw = img.width * winW / w;
								nimgh = nimgw * img.height / img.width;
							}
							else {
								nimgh = img.height * winH / h;
								nimgw = nimgh * img.width / img.height;
							}

							// not needed in Opera 12
							if (nimgw > MAXSIZE) {
								nimgw = MAXSIZE;
								nimgh = img.height * MAXSIZE / img.width;
							}

							if (nimgh > MAXSIZE) {
								nimgw = img.width * MAXSIZE / img.height;
								nimgh = MAXSIZE;
							}

							var cx = (win.scrollX + parseInt(hLayer.style.borderLeftWidth, 10) + w / 2) * nimgw / img.width - win.innerWidth / 2 - scrollbars;
							var cy = (win.scrollY + parseInt(hLayer.style.borderTopWidth, 10) + h / 2) * nimgh / img.height - win.innerHeight / 2 - scrollbars;

							img.resize(-1, nimgw + 'px', nimgh + 'px');

							win.scrollTo(cx, cy);

							fZoom = null;
							cancelAction = false;
							hLayer.innerHTML = '';
						}
						else if (dragScroll.length === 3) {
							var x = dragScroll[0][0] - dragScroll[2][0], y = dragScroll[0][1] - dragScroll[2][1];

							if ((Date.now() - img.dragScrollTime) > 100) { return; }

							if (x || y) {
								dragScroll = [x, y];
								startScroll();
								doc.addEventListener('mousewheel', stopScroll);
							}
						}
					}
				});

				img.addEventListener('click', function(e) {
					if (progress) { clearTimeout(progress); progress = null; }
					if (cancelAction) { cancelAction = false; return; }

					if (e.button !== 0 || e.shiftKey) { return; }

					if (this.dam < 2 && noFit.real) {
						if (this.dam === -1) { this.resize(0); }
						else if (win.innerWidth / win.innerHeight < this.naturalWidth / this.naturalHeight) { this.resize(2); }
						else { this.resize(3); }
					}
					else if (this.dam === 1 || noFit.cur) {
						if (this.naturalWidth === this.width && this.naturalHeight === this.height) { return; }

						var x, y;

						x = e.offsetX;
						y = e.offsetY;

						if (this.scale) {
							if (this.scale.h === -1) {
								x = this.width - e.offsetX;
							}

							if (this.scale.v === -1) {
								y = this.height - e.offsetY;
							}
						}

						x = x * this.naturalWidth / this.width - win.innerWidth / 2;
						y = y * this.naturalHeight / this.height - win.innerHeight / 2;

						this.resize(0);

						win.scrollTo(x, y);
					}
					else {
						this.resize(1);
					}
				});

				doc.addEventListener('keypress', function(e) {
					if (e.keyCode === 43 || e.keyCode === 45) {
						e.accelerate = e.ctrlKey;
						e.keypress = true;

						if (e.keyCode === 43) {
							e.wheelDelta = 1;
						}
						else {
							e.wheelDelta = -1;
						}

						e.offsetX = root.scrollLeft + img.offsetLeft + root.clientWidth / 2;
						e.offsetY = root.scrollTop + img.offsetTop + root.clientHeight / 2;
						e.clientX = root.clientWidth / 2;
						e.clientY = root.clientHeight / 2;

						img.wheelZoom(e);
					}
				});

				doc.addEventListener('keydown', function(e) {
					stopScroll();

					if ((fZoom && e.keyCode !== 27) || /^(?:TEXTAREA|INPUT|SELECT)$/.test(e.target.nodeName.toUpperCase())) { return; }

					if (e.ctrlKey) {
						if (e.shiftKey && ' 37 38 39 40 '.indexOf(' ' + e.keyCode + ' ') != -1) {
							var newpos,
							x = cfg.vw.pos.charAt(0),
							y = cfg.vw.pos.charAt(1);

							switch (e.keyCode) {
								case 37: --x; break;
								case 39: ++x; break;
								case 38: --y; break;
								case 40: ++y; break;
							}

							x < 0 ? x = '0' : x > 2 && (x = '2');
							y < 0 ? y = '0' : y > 2 && (y = '2');

							newpos = x + y;

							if (newpos != cfg.vw.pos) {
								cfg.vw.pos = newpos;
								img.setPos();
							}
						}

						return;
					}

					switch (e.keyCode) {
						case cfg.tools['key_modeAuto'] : img.resize(0); break;
						case cfg.tools['key_modeFit']: img.resize(1); break;
						case cfg.tools['key_modeFitW']: img.resize(2); break;
						case cfg.tools['key_modeFitH']: img.resize(3); break;

						case 53: img.resize(4); break;

						case cfg.tools['key_customSize'] : img.setSize(); break;

						case 27 : img.reset(); break;

						case 33 : win.scrollBy(img.hS ? -400 : 0, img.hS ? 0 : -400); e.preventDefault(); break;
						case 34 : win.scrollBy(img.hS ? 400 : 0, img.hS ? 0 : 400); e.preventDefault(); break;

						case 35 : win.scrollTo(img.hS ? root.scrollWidth : root.scrollLeft, img.hS ? root.scrollTop : root.scrollHeight); e.preventDefault(); break;
						case 36 : win.scrollTo(img.hS ? 0 : root.scrollLeft, img.hS ? root.scrollTop : 0); e.preventDefault(); break;

						case cfg.tools['key_prefs'] : oex.postMessage({'cmd': 'open', 'url': 'options.html'}); break;

						case cfg.tools['key_rotateLeft'] : img.rotate(false, e.shiftKey); break;
						case cfg.tools['key_rotateRight'] : img.rotate(true, e.shiftKey); break;
						case cfg.tools['key_rotateCustom'] : img.rotate(); break;

						case cfg.tools['key_flipH'] : transform.flip(img, 0); break;
						case cfg.tools['key_flipV'] : transform.flip(img, 1); break;

						case cfg.tools['key_imgSendTo'] : imageSendTo({'url': img.src, 'nf': e.shiftKey}); break;

						case cfg.tools['key_cycle'] : img.cycle(); break;

						case cfg.tools['key_contextMenu'] : contextmenu(); break;

						case 88 : img.hScroll(true); break;

						case 72 : e.shiftKey ? oex.postMessage({'cmd': 'history', 'data': {'image': img.src, 'get_label': true}}) : sendHistory(); break;

						case 68 :
							if (!win.onkeyup) {
								img.removeEventListener('mousedown', handle_mDown);

								win.onkeyup = function(e) {
									if (e.keyCode === 68) {
										img.addEventListener('mousedown', handle_mDown);
										win.onkeyup = null;
									}
								};
							}
						break;
					}
				});

				img.cycle = function () {
					var n_s = this.dam + 1;

					if (n_s === 1) { ++n_s; }
					else if (n_s > 3) { n_s = 0; }

					this.resize(n_s);
				};

				img.reset = function (keep_hLayer) {
					if (doc.readyState != 'complete') { return; }

					if (!keep_hLayer && hLayer) {
						fZoom = null;
						cancelAction = false;

						if (hLayer.style.display == 'block') {
							hLayer.innerHTML = '';
							hLayer.style.display = 'none';
							return;
						}

						doc.body.removeChild(hLayer);
						hLayer = null;
					}

					delete this.currentdeg;
					delete this.scale;
					this.style['OTransform'] = this.parentNode.style['backgroundSize'] = this.style.width = this.style.height = '';
					this.resize(0);
				};

				img.setSize = function () {
					setTimeout(function() {
						var size = prompt('(0 < x,y <= ' + MAXSIZE + ')\n' + LN('ORIG_DIMENS') + ': ' + img.naturalWidth + ' x ' + img.naturalHeight, '0');

						if (!size) { return; }

						size = size.trim();

						if (/^(\d{1,5}%?)(\s+\d{1,5}%?)?$/i.test(size)) {
							size = size.split(/\s+/);

							if (img.dam === 4) {
								if (size[0] == 0) { size[0] = 'auto'; }
								if (size[1] && size[1] == 0) { size[1] = 'auto'; }
								doc.body.style.backgroundSize = size.join(' ');
							}
							else {
								var w = '', h = '';

								if (parseInt(size[0], 10) > 0) {
									w = size[0].indexOf('%') > 0 ? size[0] : Math.min(Math.max(0, size[0]), MAXSIZE) + 'px';
								}

								if (size[1] && parseInt(size[1], 10) > 0) {
									h = size[1].indexOf('%') > 0 ? size[1] : Math.min(Math.max(0, size[1]), MAXSIZE) + 'px';
								}

								img.resize(-1, w, h);
							}
						}
						else { alert(LN('INCORRECT_VALUE')); }
					}, 1);
				};

				img.rotate = function (deg, fine) {
					setTimeout(function() {
						var rot = img.style['OTransform'].match(/rotate\((\-?\d+(?:\.\d+)?)deg\)/i);

						if (rot) { rot = rot[1]; }
						else { img.currentdeg = rot = 0; }

						if (deg === undefined && !/^\s*-?\d+(?:\.\d+)?\s*$/.test(deg = prompt('°:', rot))) {
							if (deg) { alert(LN('INCORRECT_VALUE')); }
							return;
						}
						else if (typeof deg == 'string') {
							deg = parseFloat(deg);
						}

						if (deg === true) { img.currentdeg += (fine ? 10 : 90); }
						else if (deg === false) { img.currentdeg -= (fine ? 10 : 90); }
						else { img.currentdeg = deg; }

						//if (img.currentdeg !== 0 && Math.cos(img.currentdeg * 0.017453292519943295) === 1) { img.currentdeg = 0; }

						win.status = img.currentdeg + '°';

						if (typeof img.currentdeg != 'undefined') { rot = 'rotate(' + img.currentdeg + 'deg)'; }
						if (img.scale) { rot += ' scale(' + img.scale.h + ',' + img.scale.v + ')'; }
						img.style['OTransform'] = rot;
					}, 1);
				};

				if (cfg.vw.minUpscale) {
					if (cfg.vw.dam === 1 && img.naturalWidth < win.innerWidth && img.naturalHeight < win.innerHeight && img.naturalWidth >= cfg.vw.minUpscale && img.naturalHeight >= cfg.vw.minUpscale) {
						img.dam = img.naturalWidth / img.naturalHeight > win.innerWidth / win.innerHeight ? 2 : 3;
					}
				}
				else if ((cfg.vw.dam === 2 && img.naturalWidth < win.innerWidth) || (cfg.vw.dam === 3 && img.naturalHeight < win.innerHeight)) {
					img.dam = 0;
				}

				img.resize(img.dam);
			}
			else if (++init.loop >= init.maxloop) {
				clearInterval(progress);
			}
		};

		(img.naturalWidth && img.naturalHeight) ? load(true) : (progress = setInterval(load, init.wait));

		oex.onmessage = function (e) {
			if (e.data['cmd'] == 'history') {
				sendHistory(null, e.data['label'].replace(/,/g, ', '));
			}
			else if (e.data['cmd'] == 'reinit') {
				cfg = e.data['prefs'];
				sub_init();
				after_calc();
			}
		};
	});

	win.onkeypress = win.onmousedown = win.onmouseup = null;
}
else {
	var isHTML = doc instanceof win['HTMLDocument'] || (doc.documentElement && root.nodeName.toUpperCase() == 'HTML'),
		mdownstart,
		rgxNewLines = /(?:\n|\r\n?)+/g,
		rgxBgURL = /"[^"]+"/g, //g for mutlitple backgrounds
		rgxProtCheck = /^\w+:/i,
		rgxQueryHash = /[\?#].*/,
		rgxHash = /#.*/,
		rgxDomain = /^(\w+:\/\/[^\/]+)\/.*/,
		rgxPath = /(\/)[^\/]*$/,
		// http://www.opera.com/docs/specs/presto211/#graphics
		rgxObjImg = /\.(?:jp(?:e|e?g)|a?png|gif|svgz?|webp|w?bmp|cur|ico|xbm|pict|j(?:if|fif?))$/i,

	checkBG = function (match/*, p*/) {
		if (match) {
			var el_images = [], imaddr, i;

			for (i in match) {
				imaddr = match[i].slice(1, -1);

				// need this check, because Opera won't prepend the baseURI to background attribute
				if (!rgxProtCheck.test(imaddr)) {
					imaddr = doc.baseURI.replace(rgxQueryHash, '').replace((imaddr.charAt(0) == '/' && node.src.charAt(1) != '/' ? rgxDomain : rgxPath), '$1') + imaddr;
				}

				el_images.push(imaddr);
			}

			//return p && el_images.length > 0 ? {path: p, imgs: el_images} : el_images;
			return el_images.length > 0 ? el_images : null;
		}

		return null;
	},

	checkIMG = function (node) {
		var nname = node.nodeName.toUpperCase();

		if (nname == 'IMG' || (node.type == 'image' && /^(?:BUTTON|INPUT)$/.test(nname)) || nname == 'EMBED') {
			return node.src;
		}
		else if (nname == 'CANVAS') {
			return node.toDataURL();
		}
		else if (nname == 'OBJECT' && node.data != ''/* && (/^image/i.test(node.type) || rgxObjImg.test(node.data))*/) {
			return node.data;
		}
		else if (nname == 'AREA') {
			var img = doc.querySelector('img[usemap="#' + node.parentNode.name + '"]');
			return img.src;
		}
		else if (nname == 'VIDEO' && node.poster != '') {
			return node.poster;
		}

		return false;
	};

	win.opera.addEventListener('BeforeEvent.mousedown', function (e) {
		if (e.event.button === 0) {
			if (!e.event.target.imagus_ && PVI && cfg.hz['loaded'] && !PVI.fullZoom && PVI.PrevDIV) {
				PVI.hide(e.event);
				PVI.fullZoom = true;

				doc.addEventListener('mouseup', function end_selection (e) {
					PVI.fullZoom = false;
					doc.removeEventListener('mouseup', end_selection);
				});
			}
		}
		else if (e.event.button === 2) { mdownstart = Date.now(); }
	});

	win.opera.addEventListener('BeforeEvent.contextmenu', function (ev) {
		var e = ev.event;

		if (e.button !== 2) { return; }

		var i, img, el, nosvg = true, bgImages = [], elapsed = (Date.now() - mdownstart) >= 300;
		mdownstart = 0;

		if (e.ctrlKey && e.altKey) {
			if (elapsed) {
				if (!cfg.tools.opfavi) { return; }

				oex.postMessage({'cmd': 'favi', nf: e.shiftKey});
			}
			else {
				if (!cfg.tools.imgSendToMSC) { return; }

				(img = checkIMG(e.target)) && imageSendTo({'url': img, 'nf': e.shiftKey});
			}

			ev.preventDefault();
			e.preventDefault();

			return;
		}

		if (e.ctrlKey && elapsed) {
			if (!cfg.tools.opseek) { return; }

			el = e.target;
			i = 13;

			while (el && i-- > 0) {
				img = checkIMG(el);
				img && bgImages.push(img);

				img = checkBG(win.getComputedStyle(el).backgroundImage.match(rgxBgURL));
				img && (bgImages = bgImages.concat(img));

				if (i === 9) {
					el = el.previousElementSibling || el.parentNode;
				}
				else {
					if (el.childElementCount) {
						el = el.lastElementChild;
					}
					else if (el.previousElementSibling) {
						el = el.previousElementSibling;
					}
					else if (el.parentNode) {
						el = el.parentNode.previousElementSibling;
					}
					else {
						el = false;
					}
				}
			}

			// need check
			el = e.target.childElementCount ? e.target.firstElementChild : (e.target.nextElementSibling || e.target.parentNode.nextElementSibling);
			i = 13;

			while (el && i-- > 0) {
				img = checkIMG(el);
				img && bgImages.push(img);

				img = checkBG(win.getComputedStyle(el).backgroundImage.match(rgxBgURL));
				img && (bgImages = bgImages.concat(img));

				if (el.childElementCount) {
					el = el.firstElementChild;
				}
				else if (el.nextElementSibling) {
					el = el.nextElementSibling;
				}
				// while el.parentNode.nextElementSibling or not
				else if (el.parentNode && el.parentNode.nextElementSibling) {
					el = el.parentNode.nextElementSibling;
				}
				else {
					el = false;
				}
			}
		}

		if ((e.altKey && cfg.tools.opimgobj || elapsed && cfg.tools.opguess) && !(e.altKey && elapsed)) {
			if (e.target.document instanceof win['SVGDocument'] || /^\[object SVG/.test(e.target.toString())) {
				nosvg = false;

				if (win != win.top) {
					bgImages.push(win.location.href);
				}
			}
			else {
				img = checkIMG(e.target);
				img && bgImages.push(img);
			}
		}

		if ((e.ctrlKey && cfg.tools.opbgimg || elapsed && cfg.tools.opguess) && !(e.ctrlKey && elapsed) && nosvg) {
			el = e.target;

			if (el.nodeName.toUpperCase() == 'HTML') {
				img = checkBG(win.getComputedStyle(el).backgroundImage.match(rgxBgURL) || win.getComputedStyle(doc.querySelector('body')).backgroundImage.match(rgxBgURL)/*, 'html>body'*/);
				img && (bgImages = bgImages.concat(img));
			}
			else {
				var imgList, comp_style, match;

				while (el && el.nodeName != '#document') {
					comp_style = win.getComputedStyle(el);
					match = comp_style.backgroundImage.match(rgxBgURL);

					if (el.nodeName.toUpperCase() == 'UL') {
						var f = comp_style.listStyleImage.match(rgxBgURL);
						if (f) {
							if (match) { match.push(f); }
							else { match = f; }
						}
					}

					imgList = checkBG(match);
					imgList && (bgImages = bgImages.concat(imgList));

					el = el.parentNode;
				}
			}
		}

		if (bgImages && bgImages.length > 0) {
			ev.preventDefault();
			e.preventDefault();

			if (!(e.ctrlKey && e.altKey) && !(e.ctrlKey && elapsed)) {
				oex.postMessage({'cmd': 'open', 'url': bgImages[0], nf: e.shiftKey});
			}
			else {
				if (bgImages.length > 1) {
					var a = [], l = bgImages.length, j;

					for (i = 0; i < l; ++i) {
						for (j = i + 1; j < l; ++j) {
							if (bgImages[i] == bgImages[j]) {
								j = ++i;
							}
						}

						a.push(bgImages[i]);
					}

					bgImages = a;
				}

				for (i = 0; i < bgImages.length; ++i) {
					oex.postMessage({'cmd': 'open', 'url': bgImages[i], nf: e.shiftKey});
				}
			}
		}
	});

	if (!isHTML) { return; }
}

var transform = {
	flip: function (el, ori) {
		if (!el.scale) { el.scale= {h: 1, v: 1 }; }

		if (ori) { el.scale.h = -el.scale.h; }
		else { el.scale.v = -el.scale.v; }

		var flip = (!el.scale.h && !el.scale.v) ? '' : 'scale('+el.scale.h+','+el.scale.v+')';
		if (el.currentdeg) { flip='rotate('+el.currentdeg+'deg) ' + flip; }
		el.style['OTransform'] = flip;
	}
},
imageSendTo = function (sf) {
	if ((!sf.url && !sf.name && !sf.url) || sf.url && !/^http/.test(sf.url)) { alert(LN('SENDTO_INVALID_URL')); return; }

	var i = 0, hosts = cfg.tools['imgSendToHosts'], go = [];

	for (; i < hosts.length; ++i) {
		if (sf.host === i || /*sf.host === -1 || */(sf.host === undefined && hosts[i][0][0] == '+')) {
			go.push(hosts[i][1].replace('%url', encodeURIComponent(sf.url)));
		}
	}

	oex.postMessage({'cmd': 'open', 'url': go, 'nf': !!sf.nf});
},
PVI = {
	PrevDIV: null,
	PrevOBJ: null,
	helper_div: null,
	target: null,
	img: null,
	imageStack: {},
	timers: {imload: null, preview: null, preload: null},
	resolving: {counter: 0, nodes: {}},
	anim: {},
	iFrame: false,
	create: function () {
		if (PVI.PrevDIV) { return; }

		root || (root = doc.documentElement);
		PVI.PrevDIV = doc.createElement('div');
		PVI.PrevOBJ = doc.createElement('object');
		PVI.PrevDIV.imagus_ = PVI.PrevOBJ.imagus_ = true;

		var bg = '', div_caption;

		if (cfg.hz['background']) {
			if (cfg.hz['background'] == 'cb') {
				bg = ';background-color:rgba(0,0,0,0);background-image:url(data:image/gif;base64,R0lGODlhFAAUAPABAOjo6P///yH5BAAKAAAALAAAAAAUABQAAAIohI+hy+jAYnhJLnrsxVBP7n1YyHVaSYKhh7Lq+VotPLo1TaW3HEtlAQA7)';
			}
			else if (/(?:http|-o-)/i.test(cfg.hz['background'])) { bg = ';background-color:rgba(0,0,0,0);background-image:' + cfg.hz['background']; }
			else { bg = ';background-color:' + cfg.hz['background']; }

			bg += ';background-clip:padding-box';
		}

		PVI.PrevDIV.style.cssText = 'position:fixed;z-index:2147483646;left:auto;top:auto;right:auto;bottom:auto;width:auto;height:auto;padding:0' + bg + (cfg.hz['shadow'] ? ';box-shadow:' + cfg.hz['shadow'] : '') + (cfg.hz['border'] ? ';border:' + cfg.hz['border'] : '') + (cfg.hz['Aopacity'] ? ';opacity:0' : '');
		PVI.PrevOBJ.style.cssText = 'display:block;width:auto;height:auto;max-width:none;max-height:none;margin:0;font:13px "Trebuchet MS",sans-serif;color:#000;border:1px solid #aaa';
		PVI.PrevOBJ.type = 'image/jpeg';
		//PVI.PrevOBJ.data = 'data:image/gif,';
		PVI.PrevDIV.appendChild(PVI.PrevOBJ);
		//'<div style="position:absolute;top:0;right:0;background-color:rgba(0,0,0,0.2);color:#fff">' +
		//'<div>rotate left right</div><div>flipv flipH</div><div>upload</div><div>zoom-zoom</div></div>' +

		if (cfg.hz['caption']) {
			div_caption = doc.createElement('div');
			div_caption.imagus_cache = div_caption.imagus_ = true;
			div_caption.style.cssText = (cfg.hz['caption'] === 1 ? 'top' : 'bottom') + ':-1em;left:0;position:absolute;width:auto;height:auto;border:0;white-space:nowrap;font:13px "Trebuchet MS",sans-serif;color:#000;background:#fff !important;padding:0 5px;border-radius:4px;color:#000 !important';
			PVI.PrevDIV.appendChild(div_caption);
		}

		PVI.PrevDIV.outsize = 2 * (cfg.hz['margin'] + (cfg.hz['border'] ? parseInt(PVI.PrevDIV.style.borderWidth, 10) : 0)) + 2;
		PVI.anim.container = [];

		if (cfg.hz['Aopacity']) {
			PVI.anim.container.push('opacity ' + cfg.hz['Aopacity'] + 'ms ' + cfg.hz['ApositionTF']);
			PVI.PrevDIV.addEventListener('oTransitionEnd', function () {
				if (!PVI.fullZoom && this.style.display == 'block' && this.style.opacity == '0') {
					PVI.reset();
				}
			});
		}

		if (cfg.hz['Aposition']) {
			PVI.anim.container.push(['top', 'right', 'bottom', 'left'].join(' ' + cfg.hz['Aposition'] + 'ms ' + cfg.hz['ApositionTF'] + ', ') + ' ' + cfg.hz['Aposition'] + 'ms ' + cfg.hz['ApositionTF']);

			!cfg.hz['Aopacity'] && PVI.PrevDIV.addEventListener('oTransitionEnd', function () {
				if (!PVI.fullZoom && this.style.display == 'block' && (parseInt(this.style.left, 10) < 0 || parseInt(this.style.right, 10) < 0)) {
					PVI.reset();
				}
			});
		}

		if (cfg.hz['Asize']) {
			PVI.PrevOBJ.style['OTransition'] = PVI.anim.obj = 'max-width ' + cfg.hz['Asize'] + 'ms ' + cfg.hz['AsizeTF'] + ', max-height ' + cfg.hz['Asize'] + 'ms ' + cfg.hz['AsizeTF'];
			PVI.PrevOBJ.addEventListener('oTransitionEnd', function () {
				if (!PVI.fullZoom && PVI.PrevDIV.style.display == 'block' && this.style.maxWidth == '0px') {
					PVI.reset();
				}
			});
		}

		if (PVI.anim.container.length) { PVI.PrevDIV.style['OTransition'] = PVI.anim.container = PVI.anim.container.join(', '); }

		root.appendChild(PVI.PrevDIV);

		PVI.helper_div = doc.createElement('div');
		PVI.helper_div.style.cssText = 'position:absolute;top:0;z-index:-666;height:100%;width:0;border:0;padding:0;margin:0;overflow:hidden';
		root.appendChild(PVI.helper_div);

		PVI.reset();
	},
	resolve: function (URL, res) {
		if (win.location.href.replace(rgxHash, '') == URL.replace(rgxHash, '')) { return false; }

		clearTimeout(PVI.timers.imload);

		PVI.timers.imload = setTimeout(function () {
			PVI.resolving.nodes[++PVI.resolving.counter] = PVI.target;
			oex.postMessage({'cmd': 'resolve', 'url': URL, 'find': res, 'id': PVI.resolving.counter});
		}, cfg.hz['hoverTime']);

		return true;
	},
	attrChanged: function (e) {
		if (e.attrChange === 1) {
			switch (e.attrName) {
				case 'href': case 'src': case 'title': case 'alt':
					delete e.target.imagus_cache;
					delete e.target.imagus_cache_resolved;
					delete e.target.imagus_target.imagus_cache;
					delete e.target.imagus_target.imagus_cache_resolved;
				break;
			}
		}
	},
	getImages: function (el) {
		var retSrcs = {imgSRC: null};

		if (el.src && (el.hasOwnProperty('alt') || el.hasOwnProperty('href'))) {
			retSrcs.imgSRC = el.src;
		}

		if ((retSrcs.imgBG = win.getComputedStyle(el).backgroundImage) == 'none') {
			retSrcs.imgBG = null;
		}
		else {
			if ((el.clientWidth < win.innerWidth / 2.3 && el.clientHeight < win.innerHeight / 2) && (retSrcs.imgBG = retSrcs.imgBG.match(rgxBgURL))) {
				retSrcs.imgBG = retSrcs.imgBG[0].slice(1, -1);
			}
			else {
				retSrcs.imgBG = null;
			}
		}

		return retSrcs;
	},
	find: function (trg, tt) {
		var i = 0, n = trg || tt, ret = false, sn, imgs = {}, found, tmp_el;

		do {
			if (n.href && n.hasOwnProperty('hreflang')) {
				if (!tt) {
					n.addEventListener('DOMAttrModified', PVI.attrChanged);

					if (trg != n) {
						n.imagus_target = trg;
					}
				}

				if ((!isRaster && win.location.href.replace(rgxHash, '') == n.href.replace(rgxHash, '')) || (!tt && trg.src && n.href == trg.src)) { break; }

				sieveloop:
				for (sn in cfg.sieve) {
					if (tt && sn == 'LinkedImages' && !cfg.hz) { continue; }

					if (cfg.sieve[sn].link && cfg.sieve[sn].link.test(n[(cfg.sieve[sn].attr && n[cfg.sieve[sn].attr] ? cfg.sieve[sn].attr : 'href')])) {
						if (cfg.sieve[sn].useimg && cfg.sieve[sn].img) {
							if (imgs.imgSRC === undefined) {
								imgs = PVI.getImages(trg || tt);
							}

							if ((imgs.imgSRC && cfg.sieve[sn].img.test(imgs.imgSRC)) || (imgs.imgBG && cfg.sieve[sn].img.test(imgs.imgBG))) {
								found = sn;
								break;
							}
						}

						if (cfg.sieve[sn].res && PVI.resolve((cfg.sieve[sn].url ? n.href.replace(cfg.sieve[sn].link, cfg.sieve[sn].url) : n.href), cfg.sieve[sn].res)) {
							ret = null;
							break;
						}

						if (Array.isArray(cfg.sieve[sn].to)) {
							ret = [];

							for (var toi = 0; toi < cfg.sieve[sn].to.length; ++toi) {
								ret.push(n.href.replace(cfg.sieve[sn].link, cfg.sieve[sn].to[toi]));

								if (ret[toi] == n.href) {
									ret.pop();
									if (!PVI.length) { tt = true; break sieveloop; }
									else if (PVI.length === 1) { ret = ret[0]; }
									break;
								}

								cfg.sieve[sn].decode && (ret[toi] = decodeURIComponent(decodeURIComponent(ret[toi])));
							}
						}
						else if (cfg.sieve[sn].to) {
							ret = n.href.replace(cfg.sieve[sn].link, cfg.sieve[sn].to);
							cfg.sieve[sn].decode && (ret = decodeURIComponent(decodeURIComponent(ret)));
						}
						else {
							ret = n.href;
						}

						break;
					}
				}

				break;
			}
		} while (++i < 5 && (n = n.parentNode));

		if (!ret && ret !== null) {
			if (imgs.imgSRC === undefined) {
				imgs = PVI.getImages(trg || tt);
			}

			if (imgs.imgSRC || imgs.imgBG) {
				var f_src = true, toi, tmp_el;

				sieveloop:
				for (sn in cfg.sieve) {
					if (found || (cfg.sieve[sn].img && ((f_src = cfg.sieve[sn].img.test(imgs.imgSRC)) || cfg.sieve[sn].img.test(imgs.imgBG)))) {
						imgs = (f_src && imgs.imgSRC ? imgs.imgSRC : imgs.imgBG);

						if (found) { sn = found; }

						if (!cfg.sieve[sn].to && cfg.sieve[sn].res && cfg.sieve[sn].url && PVI.resolve(imgs.replace(cfg.sieve[sn].img, cfg.sieve[sn].url), cfg.sieve[sn].res)) {
							ret = null;
						}
						else {
							if (Array.isArray(cfg.sieve[sn].to)) {
								ret = [];

								for (toi = 0; toi < cfg.sieve[sn].to.length; ++toi) {
									ret.push(imgs.replace(cfg.sieve[sn].img, cfg.sieve[sn].to[toi]));

									if (ret[toi] == imgs) {
										ret.pop();
										if (!PVI.length) { tt = true; break sieveloop; }
										else if (PVI.length === 1) { ret = ret[0]; }
										break;
									}

									cfg.sieve[sn].decode && (ret[toi] = decodeURIComponent(ret[toi]));
								}
							}
							else if (cfg.sieve[sn].to) {
								ret = imgs.replace(cfg.sieve[sn].img, cfg.sieve[sn].to);
								cfg.sieve[sn].decode && (ret = decodeURIComponent(ret));
							}
							else {
								ret = imgs;
							}
						}

						!tt && trg.addEventListener('DOMAttrModified', PVI.attrChanged);

						found = true;
						break;
					}
				}
			}
		}

		if (sn && cfg.sieve[sn].loop && typeof ret == 'string') {
			tmp_el = doc.createElement('a');
			tmp_el.href = ret;
			tmp_el.src = ret;
			ret = PVI.find(null, tmp_el);
		}

		if (!tt && trg.src) {
			if (typeof ret == 'string' && ret == trg.src) { ret = false; }

			if (cfg.hz['zoomResized']) {
				if (ret) {
					if (found === true) {
						trg.imagus_thumb = true;
					}
				}
				else if (ret !== null && cfg.sieve['LinkedImages'] && (trg.naturalWidth - cfg.hz['zoomResized'] > trg.clientWidth || trg.naturalHeight - cfg.hz['zoomResized'] > trg.clientHeight) && trg.clientWidth <= win.innerWidth && trg.clientHeight <= win.innerHeight) {
					ret = trg.src;
				}
			}
		}

		if (tt === true) { ret = false; }
		else if (ret || ret === null) {
			if (!tt) {
				if (cfg.hz['caption']) {
					n = trg;

					do {
						if (n.title != '') {
							trg.imagus_caption = n.title.replace(rgxNewLines, ' ').replace(/</g, '&lt;');
							break;
						}
					} while ((n = n.parentNode) && n.nodeName.toUpperCase() != 'BODY');

					if (!trg.imagus_caption) {
						if (trg.alt && trg.alt != trg.src && trg.alt != imgs) {
							PVI.create();
							PVI.helper_div.innerHTML = trg.alt.replace(rgxNewLines, ' ').replace(/</g, '&lt;');
							trg.imagus_caption = PVI.helper_div.textContent;
							PVI.helper_div.innerHTML = '';
						}
						else if (cfg.hz['captionLink'] && trg.href && trg.href != trg.textContent.trim()) {
							trg.imagus_caption = trg.textContent.trim().replace(rgxNewLines, ' ');
						}
					}
				}

				trg.title = '';

				if (typeof ret == 'string' && rgxIsSVG.test(ret)) {
					trg.imagus_SVG = true;
				}
			}
		}

		return ret;
	},
	show: function (msg) {
		if (PVI.iFrame) {
			if (typeof PVI.target.imagus_cache == 'string') {
				win.parent.postMessage({'cmd': 'from_frame', 'msg': msg, 'img': PVI.target.imagus_cache, 'caption': PVI.target.imagus_caption, 'svg': !!PVI.target.imagus_SVG}, '*');
			}

			return;
		}

		if (PVI.PrevDIV.style.display != 'block' || PVI.hiding) {
			cfg.hz['Aopacity'] && (PVI.PrevDIV.style.opacity = '1');

			if (PVI.hiding) {
				if (cfg.hz['waitHide']) { return; }
				PVI.hiding = false;
			}
			else {
				PVI.PrevDIV.style.display = 'block';
				if (!msg) { PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = '0'; }
				doc.addEventListener('mousewheel', PVI.fastHide);
				cfg.hz['Aposition'] && typeof PVI.target.imagus_cache == 'string' && PVI.show(true);
			}
		}

		var winW = Math.max(doc.body.clientWidth, root.clientWidth), winH, left, top;
		(winW > win.innerWidth) && (winW = win.innerWidth);
		winW -= PVI.PrevDIV.outsize;
		winH = PVI.helper_div.clientHeight - PVI.PrevDIV.outsize;

		var rSide = winW - PVI.x, bSide = winH - PVI.y, t = PVI.y < bSide, l = PVI.x < rSide;

		if (typeof msg == 'string') {
			PVI.PrevOBJ.textContent = msg;

			var msg_w = Math.max(msg.length * 10, PVI.PrevOBJ.clientWidth), msg_h = Math.max(20, PVI.PrevOBJ.clientHeight);

			if (cfg.hz['Asize']) {
				PVI.PrevOBJ.style.maxWidth = msg_w + 'px';
				PVI.PrevOBJ.style.maxHeight = msg_h + 'px';
			}

			left = PVI.x - (l ? 0 : msg_w + 20);
			top = PVI.y - (t ? 0 : msg_h + 20);
		}

		if (!msg && typeof PVI.target.imagus_cache == 'string') {
			var w = PVI.imageStack[PVI.target.imagus_cache][0], h = PVI.imageStack[PVI.target.imagus_cache][1],
				ratio = w / h,
				vAreaFill, hAreaFill,
				ow = w, oh = h, hminus = 0, wminus = 0;

			w = Math.min(w, winW);
			h = Math.min(h, winH);

			if (cfg.hz['placement'] === 2) {
				left = w;
				top = h;

				if (ratio < winW / winH) {
					left = ratio * h;
				}
				else {
					top = w / ratio;
				}

				left = (winW - left) / 2;
				top = (winH - top) / 2;
			}
			else {
				left = PVI.x;
				top = PVI.y;

				hAreaFill = t ? bSide : PVI.y - PVI.PrevDIV.outsize;
				hAreaFill = ratio > winW / hAreaFill ? winW : hAreaFill * ratio;
				vAreaFill = l ? rSide : PVI.x - PVI.PrevDIV.outsize;
				hAreaFill = hAreaFill > (ratio > vAreaFill / winH ? vAreaFill : winH * ratio);

				if (t) {
					if (l) {
						hAreaFill ? h = Math.min(h, bSide) : w = Math.min(w, rSide);

						if (cfg.hz['placement'] === 1) {
							hAreaFill ? left = Math.max(0, PVI.x - (PVI.PrevDIV.outsize + ratio * h) / 2) : top = Math.max(0, PVI.y - (PVI.PrevDIV.outsize + w / ratio) / 2);
						}
						else {
							hAreaFill ? left -= Math.max(0, w - rSide) : top -= Math.max(0, h - bSide);
						}
					}
					else {
						if (hAreaFill) {
							h = Math.min(h, bSide);
						}
						else {
							left = PVI.x - PVI.PrevDIV.outsize;
							w = Math.min(w, left);
						}

						if (ratio > (hAreaFill ? winW / bSide : left / winH)) {
							l = w;
							t = w / ratio;
						}
						else {
							t = h;
							l = ratio * h;
						}

						if (cfg.hz['placement'] === 1) {
							hAreaFill ? left = Math.max(0, Math.min(PVI.x - (l + PVI.PrevDIV.outsize) / 2, winW - l)) : top = Math.max(0, Math.min(PVI.y - (t + PVI.PrevDIV.outsize) / 2, winH - t));
						}
						else {
							hAreaFill ? left = Math.max(0, PVI.x - (w + PVI.PrevDIV.outsize)) : top -= Math.max(0, h - bSide);
						}

						hAreaFill || (left = Math.max(0, left - l));
					}
				}
				else {
					if (l) {
						if (hAreaFill) {
							top = PVI.y - PVI.PrevDIV.outsize;
							h = Math.min(h, top);
						}
						else {
							w = Math.min(w, rSide);
						}

						if (ratio > (hAreaFill ? winW / top : rSide / winH)) {
							l = w;
							t = w / ratio;
						}
						else {
							t = h;
							l = ratio * h;
						}

						if (cfg.hz['placement'] === 1) {
							hAreaFill ? left = Math.max(0, Math.min(PVI.x - (l + PVI.PrevDIV.outsize) / 2, winW - l)) : top = Math.max(0, Math.min(PVI.y - (t + PVI.PrevDIV.outsize) / 2, winH - t));
						}
						else {
							hAreaFill ? left -= Math.max(0, l - rSide) : top = Math.max(0, PVI.y - (t + PVI.PrevDIV.outsize));
						}

						hAreaFill && (top = Math.max(0, top - t));
					}
					else {
						if (hAreaFill) {
							top = PVI.y - PVI.PrevDIV.outsize;
							h = Math.min(h, top);
						}
						else {
							left = PVI.x - PVI.PrevDIV.outsize;
							w = Math.min(w, left);
						}

						if (ratio > (hAreaFill ? winW / top : left / winH)) {
							l = w;
							t = w / ratio;
						}
						else {
							t = h;
							l = ratio * h;
						}

						if (cfg.hz['placement'] === 1) {
							hAreaFill ? left = Math.max(0, Math.min(PVI.x - (l + PVI.PrevDIV.outsize) / 2, winW - l)) : top = Math.max(0, Math.min(PVI.y - (t + PVI.PrevDIV.outsize) / 2, winH - t));
						}
						else {
							hAreaFill ? left = Math.max(0, PVI.x - (w + PVI.PrevDIV.outsize)) : top = Math.max(0, PVI.y - (t + PVI.PrevDIV.outsize));
						}

						hAreaFill ? top = Math.max(0, top - t) : left = Math.max(0, left - l);
					}
				}
			}
		}
		else {
			left = PVI.x - (l ? 0 : PVI.PrevDIV.offsetWidth + 20);
			top = PVI.y - (t ? 0 : PVI.PrevDIV.offsetHeight + 20);
		}

		PVI.PrevDIV.style.top = (top + cfg.hz['margin']) + 'px';
		PVI.PrevDIV.style.left = (left + cfg.hz['margin']) + 'px';

		if (!msg && typeof PVI.target.imagus_cache == 'string') {
			if (PVI.target.imagus_SVG) {
				PVI.PrevOBJ.style.OObjectFit = 'contain';

				// TODO: calculate the correct width/height
				PVI.PrevOBJ.style.width = w + 'px';
				PVI.PrevOBJ.style.height = h + 'px';
			}

			PVI.PrevOBJ.style.maxWidth = w + 'px !important';
			PVI.PrevOBJ.style.maxHeight = h + 'px !important';

			cfg.hz['caption'] && (PVI.PrevDIV.lastChild.textContent = PVI.target.imagus_caption || '');// + ' ' + PVI.PrevOBJ.clientWidth + 'x' + PVI.PrevOBJ.clientHeight;
		}
	},
	hide: function (ev) {
		if (!ev.force) {
			if (!PVI.fireHide || (ev.toElement || {}).imagus_ || ((ev.fromElement || {}).imagus_ && ev.toElement == PVI.target)) {
				return;
			}

			PVI.fireHide = !PVI.fireHide;
		}

		(cfg.hz['outline'] != '') && ((ev.target.origOutline === undefined) || (ev.target.style.outline = ev.target.origOutline));

		clearInterval(PVI.timers.preview);
		clearInterval(PVI.timers.imload);

		if (PVI.fullZoom || (cfg.hz['deactivate'] && ev[cfg.hz['actTrigger'] + 'Key'])) { return; }

		PVI.x = false;

		if (PVI.iFrame) {
			if (typeof ev.fromElement.imagus_cache == 'string') {
				win.parent.postMessage({'cmd': 'from_frame', 'hide': true}, '*');
			}
		}
		else if (!PVI.fullZoom) {
			win.removeEventListener('mousemove', PVI.m_move);
		}

		if (!PVI.hiding && PVI.PrevDIV && PVI.PrevDIV.style.display == 'block') {
			if (cfg.hz['caption']) {
				PVI.helper_div.innerHTML != '' && (PVI.helper_div.innerHTML = '');
				PVI.PrevDIV.lastElementChild.innerHTML = '';
			}

			PVI.hiding = true;
			var onlypos = !cfg.hz['Asize'] && !cfg.hz['Aopacity'];

			if (onlypos || cfg.hz['Aposition']) {
				if (onlypos) {
					var winW = Math.max(doc.body.clientWidth, root.clientWidth);
					(winW > win.innerWidth) && (winW = win.innerWidth);
				}
				else {
					PVI.PrevDIV.style.top = (cfg.hz['follow'] ? ev.clientY : parseInt(PVI.PrevDIV.style.top, 10) + PVI.PrevDIV.offsetHeight / 2) + 'px';
				}

				PVI.PrevDIV.style.left = (onlypos ? -winW + ev.clientX - 30 : (cfg.hz['follow'] ? ev.clientX : parseInt(PVI.PrevDIV.style.left, 10) + PVI.PrevDIV.offsetWidth / 2)) + 'px';
			}

			if (cfg.hz['Asize']) {
				PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = PVI.PrevOBJ.data ? '0' : 'none';
			}

			cfg.hz['Aopacity'] && (PVI.PrevDIV.style.opacity = '0');
			onlypos && !cfg.hz['Aposition'] && PVI.reset();
		}
	},
	set: function (src) {
		clearInterval(PVI.timers.imload);
		PVI.create();

		if (Array.isArray(src)) {
			var src_arr_left = src.length > 1 ? src.slice(1) : false;
			src = src[0];
		}

		if (PVI.target.imagus_SVG || rgxIsSVG.test(src)) {
			PVI.target.imagus_SVG || (PVI.target.imagus_SVG = true);

			if (PVI.PrevOBJ.style.width != 'auto') { PVI.PrevOBJ.style.width = PVI.PrevOBJ.style.height = 'auto'; }

			PVI.helper_div.innerHTML = '<object data="' + src + '#IMAGUS_SVG_GET' + '" style="width:0;height:0"></object>';

			clearInterval(PVI.timers.imload);
			PVI.timers.imload = setTimeout(function () {
				!PVI.iFrame && (PVI.PrevOBJ.textContent = 'Timeout!');
				PVI.helper_div.innerHTML = '';
			}, cfg.hz['timeout']);

			PVI.show('Loading SVG...');
			return;
		}

		PVI.img = new Image();
		PVI.img.onerror = function (x) {
			clearInterval(PVI.timers.imload);

			if (x !== true) {
				PVI.target.imagus_cache_resolved = src;

				if (src_arr_left) {
					PVI.set(src_arr_left);
					throw null;
				}
			}

			PVI.PrevOBJ.textContent = (x === true ? 'Timeout!' : 'Error!');

			throw null;
		};

		PVI.img.src = src;

// it loads the page between multiple rule replacements
//alert(PVI.PrevOBJ.data)

		if (PVI.img.naturalWidth) { PVI.assign_src(src); return; }

		PVI.show('Loading...');

		var startTime = Date.now();

		PVI.timers.imload = setInterval(function () {
			if (PVI.img.naturalWidth && PVI.img.naturalHeight) {
				clearInterval(PVI.timers.imload);

				PVI.assign_src(src, true);
				return;
			}

			if (Date.now() - startTime >= cfg.hz['timeout']) { PVI.img.onerror(true); }
		}, 500);
	},
	assign_src: function (src, hide) {
		delete PVI.target.imagus_cache_resolved;

		if (PVI.target.imagus_thumb && (PVI.img.naturalWidth - cfg.hz['zoomResized'] < PVI.target.width && PVI.img.naturalHeight - cfg.hz['zoomResized'] < PVI.target.clientHeight)) {
			hide && PVI.reset();
			delete PVI.target.imagus_thumb;
			PVI.target.imagus_cache = true;
			(cfg.hz['outline'] != '') && (PVI.target.style.outline = '1px solid purple');
			return;
		}

		PVI.PrevOBJ.data = PVI.target.imagus_cache = src;
		PVI.imageStack[src] = [PVI.img.naturalWidth, PVI.img.naturalHeight];
		PVI.show();
	},
	reset: function () {
		if (!PVI.PrevDIV) { return; }

		PVI.PrevDIV.style.display = 'none';

		if (PVI.PrevOBJ.style.width != 'auto') {
			PVI.PrevOBJ.style.width = PVI.PrevOBJ.style.height = 'auto';
		}

		if (cfg.hz['Asize']) {
			PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = 'none';
			//PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = '0';
		}

		PVI.PrevDIV.style.top = PVI.PrevDIV.style.bottom = PVI.PrevDIV.style.right = PVI.PrevDIV.style.left = 'auto';
		cfg.hz['Aopacity'] && (PVI.PrevDIV.style.opacity = '0');
		delete PVI.PrevOBJ.data;
		PVI.PrevOBJ.innerHTML = '';
		cfg.hz['caption'] && (PVI.PrevDIV.lastChild.innerHTML = '');
		PVI.hiding = false;

		if ((PVI.target || {}).imagus_SVG) {
			PVI.PrevOBJ.style.OObjectFit = 'auto';
		}

		//delete this.currentdeg;
		delete PVI.PrevOBJ.scale;
		PVI.PrevOBJ.style['OTransform'] = '';

		if (PVI.fullZoom) {
			PVI.fullZoom = false;
			PVI.PrevDIV.style['OTransition'] = PVI.anim.container;
			PVI.PrevOBJ.style['OTransition'] = PVI.anim.obj;
			PVI.PrevOBJ.style.width = PVI.PrevOBJ.style.height = 'auto';
		}
	},
	toggle: function () {
		cfg.hz['loaded'] ? PVI.init(null, true) : PVI.init();
	},
	key_action: function (ev) {
		var keyCode;

		if (ev.altKey && ev.shiftKey) {
			if (ev.keyCode === 76 || ev.keyCode === 108) {
				PVI.preload();
				ev.preventDefault();
			}
			else if (ev.keyCode === 68 || ev.keyCode === 100) {
				PVI.toggle();
				ev.preventDefault();
			}
		}
		else if (PVI.target && PVI.PrevDIV && PVI.PrevDIV.style.display == 'block') {
			if (!ev.ctrlKey && !ev.altKey && !ev.metaKey) { ev.preventDefault(); }

			keyCode = String.fromCharCode(ev.keyCode).toUpperCase().charCodeAt(0);

			if ((keyCode === 43 || keyCode === 45)) { // - +
				PVI.PrevOBJ.style.width = Math.max(10, PVI.PrevOBJ.clientWidth * (keyCode === 43 ? 1.2 : 0.8)) + 'px';
				PVI.m_move({'clientX': PVI.x, 'clientY': PVI.y});
			}
			else if (!PVI.target.imagus_SVG && keyCode === cfg.tools['key_modeAuto']) {
				PVI.PrevOBJ.style.width = PVI.PrevOBJ.style.height = 'auto';
			}
			else if (keyCode === cfg.tools['key_modeFit'] || keyCode === cfg.tools['key_modeFitW'] || keyCode === cfg.tools['key_modeFitH']) {
				if ((keyCode === cfg.tools['key_modeFit'] && win.innerWidth / PVI.helper_div.clientHeight < PVI.PrevOBJ.clientWidth / PVI.PrevOBJ.clientHeight) || keyCode === cfg.tools['key_modeFitW']) {
					PVI.PrevDIV.style.left = cfg.hz['margin'] + 'px';
					PVI.PrevOBJ.style.width = (win.innerWidth - PVI.PrevDIV.outsize - (PVI.target.imagus_SVG ? 30 : 0)) + 'px';
				}
				else {
					PVI.PrevDIV.style.top = cfg.hz['margin'] + 'px';
					PVI.PrevOBJ.style.width = ((PVI.helper_div.clientHeight - PVI.PrevDIV.outsize - (PVI.target.imagus_SVG ? 30 : 0)) * PVI.PrevOBJ.offsetWidth / PVI.PrevOBJ.offsetHeight) + 'px';
				}

				if (PVI.target.imagus_SVG) {
					PVI.PrevOBJ.style.height = 'auto';
				}
			}
			else if (keyCode === 79) { // Open
				if (typeof PVI.target.imagus_cache == 'string' || typeof PVI.target.imagus_cache_resolved == 'string') {
					oex.postMessage({'cmd': 'open', 'url': (PVI.PrevOBJ.data || PVI.target.imagus_cache_resolved).replace(rgxHash, ''), nf: ev.shiftKey});
					if (!ev.shiftKey) { PVI.fastHide(); }
				}
			}
			else if (keyCode === cfg.tools['key_flipH']) { transform.flip(PVI.PrevOBJ, 0); }
			else if (keyCode === cfg.tools['key_flipV']) { transform.flip(PVI.PrevOBJ, 1); }
			else if (keyCode === 67) {
				if (ev.shiftKey) { PVI.PrevDIV.lastChild.style.display = win.getComputedStyle(PVI.PrevDIV.lastChild).display != 'block' ? 'block' : 'none'; }
				else {
					if (PVI.PrevDIV.lastChild.style.whiteSpace == 'nowrap') {
						PVI.PrevDIV.lastChild.style.whiteSpace = 'normal';
						PVI.PrevDIV.lastChild.style.minWidth = '100px';
					}
					else {
						PVI.PrevDIV.lastChild.style.whiteSpace = 'nowrap';
						PVI.PrevDIV.lastChild.style.minWidth = '0';
					}
				}
			}
			else if (keyCode === cfg.tools['key_prefs']) { oex.postMessage({'cmd': 'open', 'url': 'options.html#hzoom'}); }
			else if (keyCode === cfg.tools['key_imgSendTo']) { imageSendTo({'url': PVI.PrevOBJ.data, 'nf': ev.shiftKey}); if (!ev.shiftKey && !PVI.fullZoom) { PVI.fastHide(); } }
			else if (keyCode === 27) {
				PVI.fastHide();
			}
			else if (PVI.PrevOBJ.data && (keyCode === 90 || keyCode === 13)) { // z, enter
				if (PVI.fullZoom) {
					PVI.reset();
					!PVI.iFrame && win.removeEventListener('mousemove', PVI.m_move);
					return;
				}

				PVI.PrevDIV.style['OTransition'] = 'all 0';
				PVI.PrevOBJ.style['OTransition'] = 'all 0';
				PVI.PrevOBJ.style.maxWidth = PVI.PrevOBJ.style.maxHeight = 'none';
				PVI.PrevDIV.style.right = PVI.PrevDIV.style.bottom = 'auto';

				PVI.fullZoom = true;
				PVI.m_move({'first': true, 'clientX': PVI.x, 'clientY': PVI.y});
				!PVI.iFrame && win.addEventListener('mousemove', PVI.m_move);
				!cfg.hz['hideFZonWheel'] && doc.removeEventListener('mousewheel', PVI.fastHide);
			}
			else if (keyCode === 72) {
				if (PVI.PrevOBJ.data) {
					var hdata = {'image': PVI.PrevOBJ.data, 'size': PVI.imageStack[PVI.target.imagus_cache], 'source': {'source': win.location.href, 'target': PVI.target.href || null}};

					if (ev.shiftKey) {
						hdata.get_label = true;
						oex.postMessage({'cmd': 'history', 'data': hdata});
					}
					else {
						sendHistory(hdata);
					}
				}
			}
		}
	},
	m_over: function (ev) {
		if (ev.target.imagus_cache === true || PVI.fullZoom || (!cfg.hz['deactivate'] && cfg.hz['actTrigger'] && !ev[cfg.hz['actTrigger'] + 'Key']) ||
				(cfg.hz['deactivate'] && (!cfg.hz['actTrigger'] || ev[cfg.hz['actTrigger'] + 'Key'])) ||
				((ev.fromElement || {}).imagus_ && !PVI.hiding && ev.target == PVI.target) || (ev.toElement || {}).imagus_) { return; }

		var imgsrc, cache = ev.target.imagus_cache;

		PVI.target = ev.target;

		if (!cache && typeof PVI.target.imagus_cache_resolved == 'string') {
			imgsrc = PVI.target.imagus_cache_resolved;
			cache = false;
		}

		if (cache || (imgsrc = imgsrc || PVI.find(PVI.target)) || imgsrc === null) {
			clearTimeout(PVI.timers.preview);
			PVI.fireHide = true;
			PVI.x = ev.clientX;
			PVI.y = ev.clientY;
			!PVI.iFrame && win.addEventListener('mousemove', PVI.m_move);

			if (imgsrc && !cache && !PVI.target.imagus_cache_resolved) {
				if (cfg.hz['preload'] === 1 && cfg.hz['hoverTime'] > 50 && typeof imgsrc == 'string' && !PVI.imageStack[imgsrc]) {
					new Image().src = imgsrc;
					PVI.imageStack[imgsrc] = true;
				}

				PVI.target.imagus_cache_resolved = imgsrc;
			}

			if (PVI.hiding && !cfg.hz['waitHide'] || cfg.hz['hoverTime'] <= 50) {
				PVI.load(ev, cache, imgsrc);
				return;
			}

			if (cfg.hz['outline'] != '') {
				(typeof PVI.target.origOutline == 'string') || (PVI.target.origOutline = PVI.target.style.outline);
				PVI.target.style.outline = '1px ' + cfg.hz['outline'] + ' ' + (PVI.target.imagus_SVG ? 'blue' : 'red');
			}

			PVI.timers.preview = setTimeout(PVI.load, PVI.hiding && cfg.hz['waitHide'] ? Math.min(cfg.hz['Aopacity'], cfg.hz['Asize'], cfg.hz['Aposition']) + 50 : cfg.hz['hoverTime'], ev, cache, imgsrc);
		}
		else {
			PVI.target.imagus_cache = true;
		}
	},
	load: function (ev, cache, imgsrc) {
		PVI.target.imagus_xy = {x1: ev.clientX - ev.offsetX, y1: ev.clientY - ev.offsetY};
		PVI.target.imagus_xy.x2 = PVI.target.imagus_xy.x1 + PVI.target.offsetWidth;
		PVI.target.imagus_xy.y2 = PVI.target.imagus_xy.y1 + PVI.target.offsetHeight;

		(cfg.hz['outline'] != '') && (PVI.target.style.outline = '0');

		if (imgsrc === null) {
			PVI.create();
			delete PVI.PrevOBJ.data;
			PVI.show('Resolving...');
			return;
		}

		if (cache || (typeof imgsrc == 'string' && Array.isArray(PVI.imageStack[imgsrc]))) {
			PVI.create();
			PVI.PrevOBJ.data = cache ? PVI.target.imagus_cache : (PVI.target.imagus_cache = imgsrc);
			PVI.show();
			return;
		}

		delete PVI.PrevOBJ.data;
		PVI.set(imgsrc);
	},
	preload: function (later_added) {
		// TODO: when dom node inserted
		/*if (later_added) {
			PVI.timers.preload = setTimeout();
		}*/

		var i, l, sub_items, imgsrc;

		for (i = 0, l = doc.links.length; i < l; ++i) {
			if (doc.links[i].imagus_cache) { continue; }

			if (imgsrc = PVI.find(doc.links[i])) {
				new Image().src = Array.isArray(imgsrc) ? imgsrc[0] : imgsrc;
			}
		}

		for (i = 0, l = doc.images.length; i < l; ++i) {
			if (doc.images[i].imagus_cache) { continue; }

			if (imgsrc = PVI.find(doc.images[i])) {
				new Image().src = Array.isArray(imgsrc) ? imgsrc[0] : imgsrc;
			}
		}
	},
	m_move: function (ev) {
		if ((!cfg.hz['deactivate'] && cfg.hz['actTrigger'] && !ev[cfg.hz['actTrigger'] + 'Key']) || (cfg.hz['deactivate'] && (!cfg.hz['actTrigger'] || ev[cfg.hz['actTrigger'] + 'Key']))) {
			return;
		}

		if (PVI.fullZoom) {
			var
				w = (ev.first ? PVI.imageStack[PVI.target.imagus_cache][0] + PVI.PrevDIV.outsize - cfg.hz['margin'] * 2 : PVI.PrevDIV.offsetWidth),
				h = (ev.first ? PVI.imageStack[PVI.target.imagus_cache][1] + PVI.PrevDIV.outsize - cfg.hz['margin'] * 2 : PVI.PrevDIV.offsetHeight),
				winW = Math.max(doc.body.clientWidth, root.clientWidth),
				winH = PVI.helper_div.clientHeight;
			(winW > win.innerWidth) && (winW = win.innerWidth);

			PVI.x = ev.clientX;
			PVI.y = ev.clientY;

			PVI.PrevDIV.style.left = (w > winW ? (-(ev.clientX * (w - winW + 100) / winW) + 50) : ((winW - w) / 2)) + 'px';
			PVI.PrevDIV.style.top = (h > winH ? (-(ev.clientY * (h - winH + 100) / winH) + 50) : ((winH - h) / 2)) + 'px';
			return;
		}

		if (PVI.x !== false/* && (!cfg.hz['deactivate'] && ev[cfg.hz['actTrigger'] + 'Key'])*/) {
			PVI.x = ev.clientX;
			PVI.y = ev.clientY;

			if (ev.target.imagus_ && PVI.target.imagus_xy &&
				(PVI.target.imagus_xy.x1 > ev.clientX || PVI.target.imagus_xy.x2 < ev.clientX || PVI.target.imagus_xy.y1 > ev.clientY || PVI.target.imagus_xy.y2 < ev.clientY) ||
				(!ev.target.imagus_ && PVI.target != ev.target)) {
				PVI.hide({'force': true, 'target': PVI.target, clientX: ev.clientX, clientY: ev.clientY});
			}
			else if (cfg.hz['move'] && !PVI.hiding && PVI.PrevDIV && PVI.PrevDIV.style.display == 'block' && (cfg.hz['placement'] !== 2 || cfg.hz['placement'] === 2 && !PVI.PrevOBJ.data)) {
				PVI.show();
			}
		}
	},
	fastHide: function () {
		PVI.reset();
		!PVI.iFrame && win.removeEventListener('mousemove', PVI.m_move);
		doc.removeEventListener('mousewheel', PVI.fastHide);
	},
	winOnMessage: function (e) {
		if (e.data['cmd'] == 'svg_info') {
			if (PVI.iFrame) {
				win.parent.postMessage(e.data, '*');
				return;
			}

			// TODO: when SVG is opened in object then it loads this script too, need a hack for this

			var url = e.data['url'].replace(/#IMAGUS_SVG.*/, '');

			PVI.create();

			if (!e.data['svg']) {
				PVI.PrevOBJ.textContent = 'Error! (SVG)';
				return;
			}

			if (!PVI.imageStack[url]) {
				var w = e.data['wh']['w'], h = e.data['wh']['h'];

				if (cfg.hz['svgsale'] === 1) {
					h = 400 * h / w;
					w = 400;
				}
				else if (cfg.hz['svgsale'] === 2) {
					h = (win.screen.availWidth / 2) / (w / h);
					w = win.screen.availWidth / 2;
				}
				else if (cfg.hz['svgsale'] === 4) {
					h = win.screen.width * h / w;
					w = win.screen.width;
				}

				PVI.imageStack[url] = [w, h];
			}

			clearInterval(PVI.timers.imload);

			PVI.helper_div.innerHTML = '';
			PVI.PrevOBJ.innerHTML = '';
			PVI.PrevOBJ.data = PVI.target.imagus_cache = url;
			PVI.show();
		}
		else if (e.data['cmd'] == 'from_frame') {
			// TODO: SVG doesn't work from frame

			if (PVI.fullZoom) { return; }

			PVI.create();
			PVI.target = PVI.helper_div;

			if (e.data['hide']) {
				PVI.hide({'force': true, 'target': PVI.target, clientX: PVI.PrevDIV.offsetWidth / 2 + cfg.hz['margin'], clientY: PVI.PrevDIV.offsetHeight / 2 + cfg.hz['margin']});
				return;
			}

			PVI.x = PVI.y = 0;

			if (e.data['msg']) {
				PVI.create();
				PVI.show(e.data['msg']);
			}
			else if (e.data['img']) {
				PVI.target.imagus_caption = e.data['caption'];
				PVI.set(e.data['img']);
			}
		}
	},
	oexOnMessage: function (e) {
		if (e.data['hello']) { return; }

		if (e.data['cmd'] == 'resolved') {
			if (!e.data['m']) {
				PVI.PrevOBJ.textContent = 'Failed...';
			}
			else {
				PVI.create();

				if (PVI.target.src && PVI.target.src == e.data['m']) {
					PVI.target.imagus_cache = true;
					PVI.reset();
					(cfg.hz['outline'] != '') && (PVI.target.style.outline = '1px solid purple');
					return;
				}

				if (PVI.resolving.nodes[e.data.id] === PVI.target) {
					PVI.set(e.data['m']);
				}
				else {
					if (cfg.hz['preload'] && cfg.hz['hoverTime'] > 50 && !PVI.imageStack[e.data.m]) {
						new Image().src = e.data.m;
						PVI.imageStack[e.data.m] = true;
					}

					PVI.resolving.nodes[e.data.id].imagus_cache_resolved = e.data['m'];
				}
			}
		}
		else if (e.data['cmd'] == 'history') {
			sendHistory(e.data.data, e.data['label'].replace(/,/g, ', '));
		}
		// TODO: toggle/preload cross all frames
		else if (e.data['cmd'] == 'preload') {
			PVI.preload();
		}
		else if (e.data['cmd'] == 'toggle') {
			PVI.toggle();
		}
		else if (e.data['cmd'] == 'reinit') {
			PVI.init(null, true);
			PVI.init(e);
		}
	},
	init: function (e, deinit) {
		if (deinit) {
			win.removeEventListener('mousemove', PVI.m_move);
			PVI.PrevDIV && root.removeChild(PVI.PrevDIV);
			PVI.PrevDIV = null;
			PVI.helper_div && root.removeChild(PVI.helper_div);
			PVI.helper_div = null;
			cfg.hz['loaded'] = false;
		}
		else {
			if (e) {
				cfg = e.data['prefs'];

				if ((!cfg.hz['deactivate'] && cfg.hz['actTrigger'] == '0') || notGranted('hz') || (function () { for (var x in cfg.sieve) { return false; } return true; })()) {
					return;
				}

				convertSieveFunctions();
			}

			try {
				PVI.iFrame = win != win.top && win.parent.document.body.nodeName.toUpperCase() != 'FRAMESET';
			}
			catch (ex) {
				PVI.iFrame = true;
			}

			if (cfg.hz['preload'] === 2) {
				if (doc.readyState == 'complete') {
					PVI.preload();
				}
				else {
					doc.addEventListener('DOMContentLoaded', PVI.preload);
				}
			}

			cfg.hz['loaded'] = true;
			oex.removeEventListener('message', PVI.init);
			oex.addEventListener('message', PVI.oexOnMessage);
		}

		e = (deinit ? 'remove' : 'add');
		win[e + 'EventListener']('message', PVI.winOnMessage);
		win[e + 'EventListener']('mouseover', PVI.m_over);
		win[e + 'EventListener']('mouseout', PVI.hide);
	}
};

if (!isRaster) {
	oex.addEventListener('message', PVI.init);
	oex.addEventListener('disconnect', function() { PVI.init(null, true); oex.ondisconnect = oex.onmessage = null; });

	doc.addEventListener('DOMContentLoaded', function () {
		if (doc.body.nodeName.toUpperCase() == 'FRAMESET') {
			win.removeEventListener('keypress', PVI.key_action);
			oex.onmessage = oex.ondisconnect = null;
			PVI.init(null, true);
			return;
		}

		var exclude = doc.querySelectorAll('html, html > body, html > body > *:not(script)'), i = exclude.length;

		while (i--) {
			exclude[i].imagus_cache = true;
		}

		win.addEventListener('keypress', PVI.key_action);
	});
}

oex.postMessage({'cmd': 'hello'});

})(window, document);